#!/bin/bash

. /opt/apprecovery/scripts/src

resolve_root

distribution=`get_distro_version $_root_path`
remount_boot_device "$new_boot_dev" "$_root_path"
get_grub_efi_path $distribution || die "get_grub_efi_path" "$?"
mount_subpaths "$_root_path"

case "$distribution" in
	sles*|sled*) source /opt/apprecovery/scripts/fix_boot_sles.sh ;;
    centos6|oracle6|rhel6|centos7|rhel7|oracle7) source /opt/apprecovery/scripts/fix_boot_centos.sh ;;
    debian*|ubuntu*) source /opt/apprecovery/scripts/fix_boot_debian.sh ;;
    *) echo "The operation system is not determined. Can't proceed with the bootability fix."
	   exit 1 ;;
esac

umount_subpaths $_root_path || die "umount_subpaths" "$?"

