#!/bin/bash

install_grub()
{

    echo "Patching $new_boot_dev ..."
    chroot $_root_path /bin/bash -c "grub-install $new_boot_dev"
    chroot $_root_path /bin/bash -c "update-grub"
    chroot $_root_path /bin/bash -c "update-initramfs -t -u -k all"

}

run_efibootmgr()
{
    echo "Patching $_boot_path/efi/ ..."
    root_dev_name=$(echo "$efi_volume" | grep -Eo '^.{3}')
    echo "EFI VOLUME = $root_dev_name"
    chroot $_root_path /bin/bash -c "efibootmgr --create --disk /dev/$root_dev_name --part $1 --label $3 --loader $2" || return 1
}

mount_subpaths "$_root_path"
fix_fstab "$fstab_file" "$_root_path"

if check_efi "$_boot_path" "$fstab_file"; then
    efi_dev_number=`get_efi_dev_number $efi_volume`
    remount_efi_device "$_root_path" || die "remount efi device" "$?"
    get_grub_efi_path "$distribution" || die "get grub efi path" "$?"
    copy_efi_files || die "copy efi files" "$?"
	echo "TEST  =  $efi_dev_number, \\\\EFI\\\\BOOT\\\\${efi_file[0]}, $distribution"
    run_efibootmgr "$efi_dev_number" "\\\\EFI\\\\BOOT\\\\${efi_file[0]}" "$distribution" || die "run efibootmgr" "$?"
else
    install_grub || die "install grub" "$?"
fi
