#!/bin/bash

# D-34915: to prevent processing snapshot device
# with udev rules (probe, create uuid, btrfs scan),
# we have to avoid probe this device.
# The only place where is can be done - skip probing
# in 60-persistent-storage.rules

# This script tries to restore original rule-file
# /etc/udev/rules.d/60-persistent-storage.rules

ETC_FILE=/etc/udev/rules.d/60-persistent-storage.rules
BAK_SUFFIX=apprecovery-backup

if [ -r $ETC_FILE ]; then
    if ! grep -q APPRECOVERY-SNAP-SKIP $ETC_FILE; then
        # this file doesn't have our rule
        exit 0
    fi
    if [ -r $ETC_FILE.$BAK_SUFFIX ]; then
        mv $ETC_FILE.$BAK_SUFFIX $ETC_FILE
    else
        rm -f $ETC_FILE
    fi
fi

