/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/blkdev.h>
#include <linux/vmalloc.h>
#include <linux/math64.h>
#include <linux/bitops.h>
#include <linux/rwsem.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-cl-store.h"
#include "blksnap-cl-thread.h"
#include "blksnap-data.h"
#include "blksnap-cow-tree.h"
#include "blksnap-bitmap.h"
#include "blksnap-block.h"
#define z9d0b1ad2ad		32
typedef unsigned long zf4192f594c;static inline bool z7a6a559289(struct 
z4964f1d5f4*volume,sector_t z36fac43b50){return(z36fac43b50>=(volume->bitmap.
z19cd804e3a-1));}__always_inline static int z85708da423(struct z4964f1d5f4*
volume,struct z2c8a2d82dd*iter){next_block:iter->z212c281365++;z8afb46edca:if(!
iter->chunk->zad93bab67b||iter->z212c281365>=z6f9bab50ae)goto next_chunk;if(iter
->chunk->blocks[iter->z212c281365]){iter->block=&iter->chunk->blocks[iter->
z212c281365];return 0;}else{if(!*((zf4192f594c*)(iter->chunk->blocks+iter->
z212c281365))){iter->z212c281365+=sizeof(zf4192f594c);goto z8afb46edca;}else{
goto next_block;}}next_chunk:if(z7a6a559289(volume,iter->z36fac43b50)){up_read(&
iter->chunk->z763ed15374);return zb1240571c3;}up_read(&iter->chunk->z763ed15374)
;iter->z212c281365=0;iter->z36fac43b50++;iter->chunk=&volume->bitmap.chunks[iter
->z36fac43b50];down_read(&iter->chunk->z763ed15374);goto z8afb46edca;}static int
 z159da53264(struct z4964f1d5f4*volume,struct z2c8a2d82dd*iter,sector_t offset){
memset(iter,0,sizeof(struct z2c8a2d82dd));if(!offset)iter->chunk=&volume->bitmap
.chunks[0];else z80fe6a7329(volume,offset,iter);down_read(&iter->chunk->
z763ed15374);if(!iter->chunk->zad93bab67b)goto zb463ddc3f6;iter->block=&iter->
chunk->blocks[iter->z212c281365];if(*iter->block){return 0;}zb463ddc3f6:return 
z85708da423(volume,iter);}static inline sector_t z97f4760913(struct z4964f1d5f4*
volume,sector_t z36fac43b50,uint16_t z212c281365){return volume->start_block+((
z36fac43b50*z6f9bab50ae+z212c281365)<<zf0d12088d2);}static inline int 
zd08da5a2e0(struct z4964f1d5f4*volume){return z2dbcf3f6a8(volume,volume->
start_block,z8d7ae0fe64);}static void z4133705fab(struct z4964f1d5f4*volume){int
 i;struct z197aedd457*chunk;for(i=0;i<volume->bitmap.z19cd804e3a;i++){chunk=&
volume->bitmap.chunks[i];down_write(&chunk->z763ed15374);if(chunk->zad93bab67b){
kfree(chunk->blocks);chunk->zad93bab67b=0;chunk->blocks=NULL;}WARN_ON(chunk->
blocks);up_write(&chunk->z763ed15374);}}static sector_t z239f5b406d(struct 
z4964f1d5f4*volume){sector_t addr;addr=volume->start_sector+volume->z049dd48065;
if(addr%z7be15aefe1)addr=z0756660e7b(addr);else addr-=z7be15aefe1;return addr;}
int za4f36df3d0(struct z4964f1d5f4*volume){int i;int ret=0;sector_t alloc_size,
z70b0ee0c4a;u32 z7904609f9d;if(!volume||!volume->bdev){z5e6a2f7636(volume,1,
"Can't create block map: volume structure is incomplete");return-EINVAL;}if(
volume->bitmap.chunks){z5e6a2f7636(volume,1,"Block map is already allocated");
return-EEXIST;}if((1<<(8*sizeof(volume->bitmap.chunks->zad93bab67b)))<
z6f9bab50ae){WARN(1,"Bitmap chunk size variable has insufficient type.");return-
EBADTYPE;}if(zaa30c043a3-z6f9bab50ae+sizeof(z1a85827601)<sizeof(unsigned long*))
{WARN(1,"Bitmap chunk size can't support atomic bitmap ops.");return-ERANGE;}
volume->z049dd48065=volume->bdev->bd_part->nr_sects;volume->bitmap.last_block=
z239f5b406d(volume);z70b0ee0c4a=((volume->bitmap.last_block-volume->start_block)
>>zf0d12088d2)+1;volume->bitmap.z19cd804e3a=div_u64_rem(z70b0ee0c4a,z6f9bab50ae,
&z7904609f9d);volume->bitmap.z19cd804e3a+=z7904609f9d?1:0;alloc_size=volume->
bitmap.z19cd804e3a*sizeof(struct z197aedd457);volume->bitmap.vmalloc=false;
volume->bitmap.chunks=kzalloc(alloc_size,GFP_KERNEL|__GFP_NOWARN);if(!volume->
bitmap.chunks){volume->bitmap.chunks=vzalloc(alloc_size);if(volume->bitmap.
chunks){volume->bitmap.vmalloc=true;}else{z5e6a2f7636(volume,1,
"Failed to allocate bitmap both with kmalloc and vmalloc [%llu B]",(u64)
alloc_size);return-ENOMEM;}}for(i=0;i<volume->bitmap.z19cd804e3a;i++)init_rwsem(
&volume->bitmap.chunks[i].z763ed15374);ret=zd08da5a2e0(volume);if(ret)goto fail;
return 0;fail:z6915182530(volume);return ret;}void z6915182530(struct 
z4964f1d5f4*volume){z4133705fab(volume);if(volume->bitmap.vmalloc)vfree(volume->
bitmap.chunks);else kfree(volume->bitmap.chunks);volume->bitmap.chunks=NULL;}int
 z4fd8c166a6(struct z4964f1d5f4*volume){int ret;z4133705fab(volume);ret=
zd08da5a2e0(volume);return ret;}void z0c4f400dc1(struct z4964f1d5f4*volume){int 
rc=0;struct z2c8a2d82dd iter;rc=z159da53264(volume,&iter,0);while(!rc){if(
test_bit(z8d7ae0fe64,iter.zbfa32c9150)){clear_bit(z8d7ae0fe64,iter.zbfa32c9150);
set_bit(zbf0de702a1,iter.zbfa32c9150);}rc=z85708da423(volume,&iter);}}int 
z3fe028ac5a(struct z4964f1d5f4*volume){int rc,ret=0;sector_t addr;struct 
z2c8a2d82dd iter;if(unlikely(!z65f8f023c9(volume->zc8e6cc3a13)))return-EINVAL;
z7e01d1a51f(volume->zc8e6cc3a13);rc=z159da53264(volume,&iter,0);while(!rc){addr=
z97f4760913(volume,iter.z36fac43b50,iter.z212c281365);ret=zc9d52c740e(volume,
addr,&iter);if(ret){up_read(&iter.chunk->z763ed15374);break;}rc=z85708da423(
volume,&iter);}zdd5f2996bf(volume->zc8e6cc3a13);return ret;}void z5a088daf24(
struct z4964f1d5f4*volume){int rc;bool has_data;sector_t count=0,addr;struct 
z2c8a2d82dd iter;struct z9a6dff1010*z3398d61f51;rc=z159da53264(volume,&iter,0);
while(!rc){count++;rc=z85708da423(volume,&iter);}z0e96e5b5b4(volume,
"There are %lu changed blocks",count);if(count>z9d0b1ad2ad)return;down_read(&
volume->za087258663);rc=z159da53264(volume,&iter,0);while(!rc){addr=z97f4760913(
volume,iter.z36fac43b50,iter.z212c281365);if(test_bit(z442071e80a,iter.
zbfa32c9150)){z3398d61f51=zfe2501fe91(&volume->ze190bba191,addr);if(!z3398d61f51
){WARN(1,
"blk %llu has COW_DATA flag, but doesn't have corresponding CoW node [%x]",(u64)
addr,*iter.block);BUG();}has_data=zfce2568dba(z3398d61f51);}else{has_data=false;
}printk(KERN_INFO"%s%llu%s",test_bit(zbf0de702a1,iter.zbfa32c9150)?"!":"",(
unsigned long long)addr,has_data?"- ":" ");rc=z85708da423(volume,&iter);}up_read
(&volume->za087258663);}static bool ze019ef940c(struct z4964f1d5f4*volume,const 
unsigned long*block){if(test_bit(zbf0de702a1,block)&&volume->disk)return true;if
(test_bit(z8d7ae0fe64,block)&&!volume->disk)return true;return false;}sector_t 
z099115335d(struct z4964f1d5f4*volume){int rc;struct z2c8a2d82dd iter;sector_t 
total=0;rc=z159da53264(volume,&iter,0);while(!rc){if(ze019ef940c(volume,iter.
zbfa32c9150))total++;rc=z85708da423(volume,&iter);}return total;}u32 z3e7800bfb2
(struct z4964f1d5f4*volume,struct zcf68ae59ee extents[],u32 z473eb14421,sector_t
 offset){int rc;sector_t addr;struct z2c8a2d82dd iter;const sector_t z022ef87ee7
=volume->start_block;sector_t prev_block=0;sector_t zb15716c735;bool ze8128b2837
=false;u32 z801feefee2=0;rc=z159da53264(volume,&iter,offset);while(!rc){if(!
ze019ef940c(volume,iter.zbfa32c9150))goto next_block;addr=z97f4760913(volume,
iter.z36fac43b50,iter.z212c281365);zb15716c735=addr-z022ef87ee7;if(!ze8128b2837)
{prev_block=zb15716c735;extents[z801feefee2].nblocks=1;extents[z801feefee2].
start_sect=prev_block;ze8128b2837=true;goto next_block;}if(zb15716c735!=
prev_block+z7be15aefe1){if(z801feefee2>=z473eb14421-1){up_read(&iter.chunk->
z763ed15374);break;}z801feefee2++;extents[z801feefee2].nblocks=1;extents[
z801feefee2].start_sect=zb15716c735;}else{extents[z801feefee2].nblocks++;}
prev_block=zb15716c735;next_block:rc=z85708da423(volume,&iter);}return 
z801feefee2+((ze8128b2837==true)?1:0);}
#ifdef z2b46589a0e
void z36e5d4ea4e(sector_t addr,const struct z2c8a2d82dd*index){if(unlikely(!(
test_bit(zbf0de702a1,index->zbfa32c9150)||test_bit(z8d7ae0fe64,index->
zbfa32c9150)))){z8be79bb9f5("BUG: %s: block [%lu] flags: %.8x",__func__,addr,
index->block);BUG();}}
#else
void z36e5d4ea4e(sector_t addr,const struct z2c8a2d82dd*index){}
#endif
int zc11a30e286(struct z4964f1d5f4*volume,bool cancel){int ret=0,rc;sector_t 
addr;struct z2c8a2d82dd iter;unsigned int remove=0,remain=0;if(unlikely(!
z65f8f023c9(volume->zc8e6cc3a13)))return-EINVAL;z7e01d1a51f(volume->zc8e6cc3a13)
;rc=z159da53264(volume,&iter,0);while(!rc){addr=z97f4760913(volume,iter.
z36fac43b50,iter.z212c281365);z36e5d4ea4e(addr,&iter);if(test_bit(z8d7ae0fe64,
iter.zbfa32c9150)){clear_bit(zbf0de702a1,iter.zbfa32c9150);remain++;}else{if(
test_bit(zbf0de702a1,iter.zbfa32c9150)){if(cancel){set_bit(z8d7ae0fe64,iter.
zbfa32c9150);clear_bit(zbf0de702a1,iter.zbfa32c9150);remain++;}else{z75bb55c017(
volume,&iter);remove++;goto next_block;}}else{z5e6a2f7636(volume,1,
"block %llu (%x) sanity check failed on stopping snapshot",(u64)addr,*iter.block
);ret=1;up_read(&iter.chunk->z763ed15374);break;}}if(unlikely(test_bit(
zbf0de702a1,iter.zbfa32c9150)||!test_bit(z8d7ae0fe64,iter.zbfa32c9150))){WARN(1,
"Block [%llu] has invalid flags [%x] after clearing bitmap on stopping snapshot"
,(u64)addr,*iter.block);ret=1;up_read(&iter.chunk->z763ed15374);break;}ret=
zc9d52c740e(volume,addr,&iter);if(ret){up_read(&iter.chunk->z763ed15374);break;}
next_block:rc=z85708da423(volume,&iter);}if(!ret){ret=zd08da5a2e0(volume);
zdd5f2996bf(volume->zc8e6cc3a13);}if(!ret)z0e96e5b5b4(volume,
"Bitmap prune: removed %u blocks (%u remained)",remove,remain);else z0e96e5b5b4(
volume,"WARNING: Bitmap prune is aborted due errors");return ret;}

























