/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/types.h>
#include <linux/bitops.h>
#include <linux/math64.h>
#include <linux/rwsem.h>
#include "blksnap-volume.h"
#include "blksnap-device.h"
#include "blksnap-bitmap.h"
#include "blksnap-block.h"
#define zd80a033173(volume, addr)				       \
	if (unlikely(addr < volume->start_block				       \
		     || addr > volume->bitmap.last_block)) {		       \
		z5e6a2f7636(volume, 1, "invalid sector address %llu in  %s()", \
			    (u64) addr, __func__);			       \
		BUG();							       \
	}
static int z734a512c31(struct z197aedd457*z197aedd457){z1a85827601*new;if(
z197aedd457->blocks)return 0;new=kzalloc(zaa30c043a3,GFP_KERNEL);if(!new){
WARN_ONCE(1,"Can't allocate bitmap chunk");return-ENOMEM;}down_write(&
z197aedd457->z763ed15374);if(z197aedd457->blocks){up_write(&z197aedd457->
z763ed15374);kfree(new);return 0;}WARN_ON(z197aedd457->zad93bab67b);z197aedd457
->blocks=new;up_write(&z197aedd457->z763ed15374);return 0;}static void 
z78ef62fd5e(struct z2c8a2d82dd*index){down_write(&index->chunk->z763ed15374);if(
index->chunk->zad93bab67b)goto unlock;kfree(index->chunk->blocks);index->chunk->
blocks=NULL;unlock:up_write(&index->chunk->z763ed15374);}__always_inline void 
z80fe6a7329(struct z4964f1d5f4*volume,sector_t z3fddaf21b5,struct z2c8a2d82dd*
index){sector_t z9a85fbbdb2=(z3fddaf21b5-volume->start_block)>>zf0d12088d2;index
->z36fac43b50=div_u64_rem(z9a85fbbdb2,z6f9bab50ae,&index->z212c281365);index->
chunk=&volume->bitmap.chunks[index->z36fac43b50];}int z2b33a5c958(struct 
z4964f1d5f4*volume,sector_t addr,u8 bit){int ret;struct z2c8a2d82dd index;
zd80a033173(volume,addr);z80fe6a7329(volume,addr,&index);down_read(&index.chunk
->z763ed15374);if(!index.chunk->zad93bab67b)ret=0;else ret=test_bit(bit,(
unsigned long*)&index.chunk->blocks[index.z212c281365]);up_read(&index.chunk->
z763ed15374);return ret;}int z2dbcf3f6a8(struct z4964f1d5f4*volume,sector_t addr
,u8 bit){int ret;struct z2c8a2d82dd index;zd80a033173(volume,addr);z80fe6a7329(
volume,addr,&index);down_read(&index.chunk->z763ed15374);while(!index.chunk->
blocks){up_read(&index.chunk->z763ed15374);ret=z734a512c31(index.chunk);if(ret)
return ret;down_read(&index.chunk->z763ed15374);}index.block=&index.chunk->
blocks[index.z212c281365];if(!test_and_set_bit(CHANGED,index.zbfa32c9150))index.
chunk->zad93bab67b++;set_bit(bit,index.zbfa32c9150);up_read(&index.chunk->
z763ed15374);return 0;}__always_inline bool z669625f124(struct z4964f1d5f4*
volume,struct z2c8a2d82dd*index,u8 bit){if(!test_and_set_bit(CHANGED,index->
zbfa32c9150))index->chunk->zad93bab67b++;return test_and_set_bit(bit,index->
zbfa32c9150);}int zbb6fd84b49(struct z4964f1d5f4*volume,sector_t addr,u8 bit,
bool*res){int ret;struct z2c8a2d82dd index;zd80a033173(volume,addr);z80fe6a7329(
volume,addr,&index);down_read(&index.chunk->z763ed15374);while(!index.chunk->
blocks){up_read(&index.chunk->z763ed15374);ret=z734a512c31(index.chunk);if(ret)
return ret;down_read(&index.chunk->z763ed15374);}index.block=&index.chunk->
blocks[index.z212c281365];*res=z669625f124(volume,&index,bit);up_read(&index.
chunk->z763ed15374);return 0;}bool z16bb2b3155(struct z4964f1d5f4*volume,
sector_t addr){struct z2c8a2d82dd index;bool ret;zd80a033173(volume,addr);
z80fe6a7329(volume,addr,&index);down_read(&index.chunk->z763ed15374);if(!index.
chunk->zad93bab67b)ret=false;else ret=!!index.chunk->blocks[index.z212c281365];
up_read(&index.chunk->z763ed15374);return ret;}void zca01cbe326(struct 
z4964f1d5f4*volume,sector_t addr,u8 bit){struct z2c8a2d82dd index;zd80a033173(
volume,addr);z80fe6a7329(volume,addr,&index);down_read(&index.chunk->z763ed15374
);if(!index.chunk->zad93bab67b)goto unlock;index.block=&index.chunk->blocks[
index.z212c281365];if(!(*index.block&(1<<bit)))goto unlock;clear_bit(bit,index.
zbfa32c9150);if(!(*index.block&z4391f5396f)&&test_and_clear_bit(CHANGED,index.
zbfa32c9150)){index.chunk->zad93bab67b--;if(!index.chunk->zad93bab67b){up_read(&
index.chunk->z763ed15374);z78ef62fd5e(&index);return;}}unlock:up_read(&index.
chunk->z763ed15374);}void z75bb55c017(struct z4964f1d5f4*volume,struct 
z2c8a2d82dd*index){if(!test_and_clear_bit(CHANGED,index->zbfa32c9150))return;*
index->block=0;index->chunk->zad93bab67b--;if(!index->chunk->zad93bab67b){
up_read(&index->chunk->z763ed15374);z78ef62fd5e(index);down_read(&index->chunk->
z763ed15374);}}
