/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/kernel.h>
#include <linux/err.h>
#include <linux/types.h>
#include <linux/blkdev.h>
#include <asm/string.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-cl-store.h"
#include "blksnap-cl-buffer.h"
#define z252e0564dc	2
#define z14999da051	PAGE_SIZE
#define zd969e27940	(z14999da051 / sizeof(sector_t))
struct z02665e35eb{sector_t buf[zd969e27940];unsigned int position;struct 
z02665e35eb*next,*prev;};struct z31cf2509da{struct z02665e35eb*zd8e4721363;
zecbbb4c420 z18348db3fd;ze479158afc z2554272c42;struct zde54fc0c64 statistics;
struct mutex z25465748ba;void*z303e10aafa,*zdeb167548f;};static int zbc7b33d415(
struct z31cf2509da*buffer,struct z02665e35eb*page){int res=0;res=buffer->
z18348db3fd(page,buffer->z303e10aafa);if(res){z8be79bb9f5(
"ERROR: %s got error %d in flush callback",__func__,res);buffer->statistics.
error_count++;}return res;}static inline bool z9e2c31eb95(struct z02665e35eb*
page){if(zb1d2e81594(page,__func__))return true;return page->position==
zd969e27940;}static int z92f228b4b3(struct z31cf2509da*buffer){struct 
z02665e35eb*page,*z7f276eec12,*z31bb3916ac;page=kzalloc(sizeof(*page),GFP_KERNEL
);if(!page){z8be79bb9f5("ERROR: %s: Failed to allocate page",__func__);return-
ENOMEM;}buffer->statistics.zee5cbe8141++;if(buffer->zd8e4721363){z7f276eec12=
buffer->zd8e4721363->next;z31bb3916ac=buffer->zd8e4721363;page->prev=z31bb3916ac
;page->next=z7f276eec12;z7f276eec12->prev=page;z31bb3916ac->next=page;}else{
buffer->zd8e4721363=page;buffer->zd8e4721363->next=page;buffer->zd8e4721363->
prev=page;}return 0;}static int zf75c7b7353(struct z31cf2509da*buffer,struct 
z02665e35eb*page){int res=0;if(page->next!=page){page->prev->next=page->next;
page->next->prev=page->prev;if(page==buffer->zd8e4721363)buffer->zd8e4721363=
page->next;}else{if(buffer->zd8e4721363!=page){z8be79bb9f5(
"Wrong page address to remove");return-EINVAL;}buffer->zd8e4721363=NULL;}if(page
->position&&!z9e2c31eb95(page))res=z7c65b05520(buffer,page);kfree(page);buffer->
statistics.zee5cbe8141--;return res;}struct z31cf2509da*zf1546d8ccb(zecbbb4c420 
z18348db3fd,void*zbf5bfffd4d,ze479158afc z2554272c42,void*z5220c5917e){struct 
z31cf2509da*buffer;int i,err=0;buffer=kzalloc(sizeof(*buffer),GFP_KERNEL);if(!
buffer){z8be79bb9f5("ERROR: %s: Can not allocate buffer memory",__func__);return
 ERR_PTR(-ENOMEM);}mutex_init(&buffer->z25465748ba);buffer->z18348db3fd=
z18348db3fd;buffer->z2554272c42=z2554272c42;buffer->z303e10aafa=zbf5bfffd4d;
buffer->zdeb167548f=z5220c5917e;mutex_lock(&buffer->z25465748ba);for(i=0;i<
z252e0564dc;i++){err=z92f228b4b3(buffer);if(err)goto zc7f1a6a036;}mutex_unlock(&
buffer->z25465748ba);return buffer;zc7f1a6a036:mutex_unlock(&buffer->z25465748ba
);if(z6f4ee1de48(buffer))z8be79bb9f5("ERROR: %s: Buffer destroy failed",__func__
);return ERR_PTR(err);}int z6f4ee1de48(struct z31cf2509da*buffer){int res=0;
mutex_lock(&buffer->z25465748ba);while(buffer->zd8e4721363&&!res)res=zf75c7b7353
(buffer,buffer->zd8e4721363->next);mutex_unlock(&buffer->z25465748ba);kfree(
buffer);return res;}int z0e321a71f8(struct z31cf2509da*buffer,sector_t addr){int
 res=0;mutex_lock(&buffer->z25465748ba);if(unlikely(!buffer->zd8e4721363)){
z8be79bb9f5("No page available in cycle buffer");mutex_unlock(&buffer->
z25465748ba);return-EINVAL;}buffer->zd8e4721363->buf[buffer->zd8e4721363->
position]=addr;buffer->zd8e4721363->position++;buffer->statistics.zd1c66b1d2c++;
if(unlikely(z9e2c31eb95(buffer->zd8e4721363))){struct z02665e35eb*z00c53ec33d=
NULL;if(z9e2c31eb95(buffer->zd8e4721363->next)){res=z92f228b4b3(buffer);if(res){
z8be79bb9f5("ERROR: %s: Unable to add new page [%d]",__func__,res);buffer->
statistics.error_count++;}buffer->statistics.z92c171ae6e++;}z00c53ec33d=buffer->
zd8e4721363;buffer->zd8e4721363=buffer->zd8e4721363->next;res=zbc7b33d415(buffer
,z00c53ec33d);if(res){z8be79bb9f5("ERROR: %s: Unable to flush buffer page [%d]",
__func__,res);buffer->statistics.error_count++;}}mutex_unlock(&buffer->
z25465748ba);return res;}int z0f7dd0c98f(struct z31cf2509da*buffer,struct 
zde54fc0c64*stats){memcpy(stats,&buffer->statistics,sizeof(buffer->statistics));
return 0;}static int zc072be61ee(struct z02665e35eb*page){page->position=0;
memset((unsigned char*)page->buf,0,z14999da051);return 0;}int z7c65b05520(struct
 z31cf2509da*buffer,struct z02665e35eb*page){int res=0;res=buffer->z2554272c42((
sector_t*)page->buf,z14999da051,buffer->zdeb167548f);if(res){z8be79bb9f5(
"ERROR: %s: Unable to write changes [%d]",__func__,res);buffer->statistics.
error_count++;return res;}buffer->statistics.zaf2c60c072++;z914493833d(buffer->
zdeb167548f,page->position*sizeof(sector_t));res=zc072be61ee(page);return res;}
