/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/blkdev.h>
#include <linux/vmalloc.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-extent.h"
#include "blksnap-device-utils.h"
#include "blksnap-volume.h"
#include "blksnap-data.h"
#include "blksnap-cow-tree.h"
#include "blksnap-bio.h"
#include "blksnap-bio-submit.h"
#include "blksnap-bitmap.h"
#include "blksnap-block.h"
#include "blksnap-cl-buffer.h"
#include "blksnap-cl-thread.h"
#include "blksnap-cl-store.h"
#define zcc399a7414(sectors) ((sectors << SECTOR_SHIFT) / sizeof(sector_t))
inline void z85ab8d249a(struct z1889054767*store){store->stat.blocks++;}inline 
void zd739335037(struct z1889054767*store){store->stat.added++;}void z914493833d
(struct z1889054767*store,uint64_t bytes){if(bytes%PAGE_SIZE)bytes-=sizeof(
sector_t);store->usage=(store->usage%PAGE_SIZE)?(store->usage&~(PAGE_SIZE-1))+
bytes:store->usage+bytes;}void z0acaa4b0b4(void*data){struct z1889054767*store=(
struct z1889054767*)data;int res;if(unlikely(!z65f8f023c9(store)))return;res=
z530f7bfcf5(store);if(res)z5769993871(store->bdev,
"ERROR: resetting cl store failed with error code: %d",res);atomic_set(&store->
status,z9a011193b0);}static int z010408563d(sector_t*zc7dd358f9d,unsigned int 
len,void*data){struct z1889054767*store=(struct z1889054767*)data;int ret=-
EINVAL;sector_t z3016714a10;z9e7b9d39c7("%s(%p, %u, %p)",__func__,zc7dd358f9d,
len,store);if(!store)return-EINVAL;if(z03c66388ea(store)!=zef9665eea7&&
z03c66388ea(store)!=zba42d09742)return-z7650f15e91;if(len%SECTOR_SIZE){
z5769993871(store->bdev,
"ERROR: length of buffer passed to %s() MUST be aligned to %d bytes",__func__,
SECTOR_SIZE);return-EINVAL;}z3016714a10=len>>SECTOR_SHIFT;while(z3016714a10){
unsigned int z6cc7687f72;sector_t zef7b339f03;z6cc7687f72=MIN(store->cur_pos.ext
->z049dd48065-store->cur_pos.pos,z3016714a10);if(!z6cc7687f72){store->cur_pos.
pos=0;store->cur_pos.ext=store->cur_pos.ext->next;if(unlikely(!store->cur_pos.
ext)){return-EIO;}continue;}zef7b339f03=z18e6cf5184(store->bdev,store->cur_pos.
ext->start);z9e7b9d39c7("%s(%p, %u, %p) blksnap_disk_io(%llu, %llu)",__func__,
zc7dd358f9d,len,store,zef7b339f03+store->cur_pos.pos,z6cc7687f72<<SECTOR_SHIFT);
ret=z323d633002(store->bdev,zef7b339f03+store->cur_pos.pos,z6cc7687f72<<
SECTOR_SHIFT,(unsigned char*)zc7dd358f9d,ze6aa9c5214);if(unlikely(ret))break;
z3016714a10-=z6cc7687f72;zc7dd358f9d+=z6cc7687f72<<SECTOR_SHIFT;store->cur_pos.
pos+=z6cc7687f72;}return ret;}static int z33269dcb59(sector_t*buf,int 
z8a6e2124f1){sector_t*pos=buf;for(;(pos-buf<z8a6e2124f1)&&*pos;pos++);return pos
-buf;}static int ze689c8bb3b(struct block_device*bdev,sector_t*buf,int 
z8a6e2124f1){sector_t sector,*pos=buf;struct z4964f1d5f4*volume;bool commit=true
;int blocks;int err;volume=z2ee27eb651(bdev);if(!volume){z5769993871(bdev,
"ERROR: no blksnap volume for block device");return-EINVAL;}blocks=z33269dcb59(
buf,z8a6e2124f1);if(blocks<z8a6e2124f1)commit=false;while(pos-buf<blocks){sector
=*pos++;err=z2dbcf3f6a8(volume,sector,z8d7ae0fe64);if(unlikely(err))return err;
if(commit)z2dbcf3f6a8(volume,sector,COMMITTED);}return pos-buf;}static int 
z6a16066ada(struct z1889054767*store){int blocks,ret;sector_t*buf;uint64_t 
z3016714a10,zc65f327588;struct z718cdad054*z828c7338cb;const unsigned int 
z4b24eacc94=BIO_MAX_SIZE>>SECTOR_SHIFT;buf=vmalloc(z4b24eacc94<<SECTOR_SHIFT);if
(!buf){z8be79bb9f5("ERROR: Unable to allocate memory in %s",__func__);return-
ENOMEM;}store->cur_pos.ext=store->extents.head;store->cur_pos.pos=0;z828c7338cb=
store->extents.head;do{zc65f327588=0;while(z828c7338cb->z049dd48065>zc65f327588)
{z3016714a10=MIN(z828c7338cb->z049dd48065-zc65f327588,z4b24eacc94);ret=
z323d633002(store->bdev,z18e6cf5184(store->bdev,z828c7338cb->start)+zc65f327588,
z3016714a10<<SECTOR_SHIFT,(unsigned char*)buf,z11482db68b);if(ret)goto end;
blocks=ze689c8bb3b(store->bdev,buf,zcc399a7414(z3016714a10));if(blocks<0){ret=
blocks;goto end;}store->usage+=blocks*sizeof(sector_t);if(blocks<zcc399a7414(
z3016714a10))goto end;zc65f327588+=z3016714a10;}z828c7338cb=z828c7338cb->next;}
while(z828c7338cb);if(!z828c7338cb){z5769993871(store->bdev,
"ERROR: changelog store is full");ret=-za17c59f438;}end:if(!ret){store->cur_pos.
ext=z828c7338cb;store->cur_pos.pos=zc65f327588;}vfree(buf);return ret;}int 
z530f7bfcf5(struct z1889054767*store){int ret;sector_t*buf;uint64_t z3016714a10;
if(zb1d2e81594(store,__func__)||zb1d2e81594(store->bdev,__func__)||zb1d2e81594(
store->extents.head,__func__))return-EINVAL;buf=kzalloc(PAGE_SIZE,GFP_KERNEL);if
(!buf){z8be79bb9f5("ERROR: Unable to allocate memory in %s",__func__);return-
ENOMEM;}z3016714a10=MIN(store->extents.head->z049dd48065,z7be15aefe1);ret=
z323d633002(store->bdev,z18e6cf5184(store->bdev,store->extents.head->start),
z3016714a10<<SECTOR_SHIFT,(unsigned char*)buf,ze6aa9c5214);store->cur_pos.ext=
store->extents.head;store->cur_pos.pos=0;store->usage=0;kfree(buf);return ret;}
static int z1eeacaa283(struct z1889054767*store){int ret=0;store->opts.
zb2cdec2b3c=z0acaa4b0b4;store->opts.z5b953eb9a6=store;store->opts.z09b0ab5d86=
z010408563d;store->opts.z89bcebbeb9=store;store->thread=z3b40f7a090(&store->opts
,store->bdev);if(IS_ERR(store->thread)){ret=PTR_ERR(store->thread);store->thread
=NULL;}return ret;}int z2bf1648a51(struct z4964f1d5f4*volume,struct z87953c6ebf*
map,int operation){int z66bc8d3488,ret=0;struct z718cdad054*new;struct 
z1889054767*store=volume->zc8e6cc3a13;mutex_lock(&store->lock);if(atomic_read(&
store->status)==z9a011193b0){ret=-EINVAL;goto unlock;}if(ze79cbbfa4a(map)){if(
atomic_read(&store->status)!=z8eeb6555f3){ret=-EEXIST;goto unlock;}atomic_set(&
store->status,zdac4bfcb2a);}for(z66bc8d3488=0;z66bc8d3488<map->z473eb14421;
z66bc8d3488++){new=z76133370d0(map->extents[z66bc8d3488].start_sect,map->extents
[z66bc8d3488].z049dd48065,store->extents.head);if(IS_ERR(new)){ret=PTR_ERR(new);
goto z86508c4c64;}store->extents.head=new;store->size+=map->extents[z66bc8d3488]
.z049dd48065<<SECTOR_SHIFT;}if(zdc056c7b40(map)){if((operation&z0512bfc224)&&(
operation&MAP_READ)){z5769993871(store->bdev,
"ERROR: empty operation set for mapping changelog store (%d)\n",operation);ret=-
EINVAL;goto z86508c4c64;}store->cur_pos.ext=store->extents.head;store->cur_pos.
pos=0;if(operation&MAP_READ){ret=z6a16066ada(store);}else{if(operation&
z0512bfc224){ret=z530f7bfcf5(store);}else{z5769993871(store->bdev,
"ERROR: bad operation set for mapping changelog store (%d)\n",operation);ret=-
EINVAL;}}if(ret)goto z86508c4c64;ret=z1eeacaa283(store);if(ret){z5769993871(
store->bdev,"ERROR: Changelog store is NOT mapped [%d]",ret);goto z86508c4c64;}
atomic_set(&store->status,zef9665eea7);if(operation&MAP_WRITE)ret=z3fe028ac5a(
volume);zecd82a79ce(store->extents.head,store->bdev,"chlog");z5769993871(store->
bdev,"Changelog store is mapped (disk: %llu/%llu) [%s %s %s]",store->usage,store
->size,(operation&MAP_READ)?"rd":"-",(operation&z0512bfc224)?"rst":"-",(
operation&MAP_WRITE)?"wr":"-");}unlock:mutex_unlock(&store->lock);return ret;
z86508c4c64:atomic_set(&store->status,z9a011193b0);z1acc38b162(store->extents.
head);store->extents.head=NULL;goto unlock;}struct z1889054767*z11f0a50e6f(
struct block_device*bdev){struct z1889054767*store;store=kzalloc(sizeof(struct 
z1889054767),GFP_KERNEL);if(!store){z5769993871(bdev,
"ERROR: failed to allocate memory for changelog store");return ERR_PTR(-ENOMEM);
}store->bdev=bdev;mutex_init(&store->extents.lock);mutex_init(&store->lock);
return store;}void z143c8e7765(struct z1889054767*store){if(!store)return;if(!
z65f8f023c9(store))return;mutex_lock(&store->lock);atomic_set(&store->status,
zba42d09742);if(store->thread){zf93edaa01a(store->thread,0UL);zc7c93d5adb(store
->thread);}mutex_unlock(&store->lock);z5769993871(store->bdev,
"Changelog store is commited (disk: %llu/%llu)",store->usage,store->size);if(
store->extents.head)z1acc38b162(store->extents.head);kfree(store);}int 
z03c66388ea(struct z1889054767*store){if(!store)return z8eeb6555f3;return 
atomic_read(&store->status);}int zc9d52c740e(struct z4964f1d5f4*volume,sector_t 
addr,struct z2c8a2d82dd*index){struct z1889054767*zeafdb7e4ef=volume->
zc8e6cc3a13;if(!addr)return 0;z85ab8d249a(zeafdb7e4ef);if(z669625f124(volume,
index,COMMITTED))return 0;zd739335037(zeafdb7e4ef);return zf93edaa01a(
zeafdb7e4ef->thread,addr);}int zf274290909(struct z4964f1d5f4*volume,sector_t 
addr,bool stat){int ret;bool committed;struct z1889054767*zeafdb7e4ef=volume->
zc8e6cc3a13;if(!addr)return 0;if(stat)z85ab8d249a(zeafdb7e4ef);ret=zbb6fd84b49(
volume,addr,COMMITTED,&committed);if(ret||committed)return ret;if(stat)
zd739335037(zeafdb7e4ef);return zf93edaa01a(zeafdb7e4ef->thread,addr);}
