/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/spinlock.h>
#include <linux/err.h>
#include <linux/kthread.h>
#include <linux/blkdev.h>
#include <linux/slab.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-cl-buffer.h"
#include "blksnap-cl-thread.h"
#define zbec9fe98c2	"cl"
static struct kmem_cache*zfa5cdab594;enum z084b8d3002{z589134ccf5,z936faf5bbe};
struct z27819d90ee{enum z084b8d3002 command;void*data;sector_t z874adccce4;
struct list_head list;};struct zc723a33f7c{wait_queue_head_t zeddfb42eb7;struct 
z31cf2509da*z9e05597b05;struct task_struct*task;struct z2f16773ac7 options;
struct list_head z44f09fd585;spinlock_t lock;};int z1a91c81d9a(void){if(unlikely
(zfa5cdab594)){WARN(1,"Detected try to re-create a cache, %s",__func__);return-
EEXIST;}zfa5cdab594=KMEM_CACHE(z27819d90ee,0);if(!zfa5cdab594){z8be79bb9f5(
"ERROR: Can't create cache in %s",__func__);return-ENOMEM;}return 0;}void 
ze22d030cb5(void){if(unlikely(!zfa5cdab594)){WARN(1,
"Detected try to destroy an empty cache, %s",__func__);return;}
kmem_cache_destroy(zfa5cdab594);zfa5cdab594=NULL;}static int z94a5c55213(struct 
list_head*list){return list_empty(list);}static void z3ffe5a25a2(struct 
zc723a33f7c*thread,struct z27819d90ee*entry){list_add_tail(&entry->list,&thread
->z44f09fd585);wake_up(&thread->zeddfb42eb7);}static void z7a37fba5bf(struct 
zc723a33f7c*thread,struct z27819d90ee*entry){spin_lock_irq(&thread->lock);
z3ffe5a25a2(thread,entry);spin_unlock_irq(&thread->lock);}static void 
z22956b88fe(struct zc723a33f7c*thread,struct z27819d90ee*entry){unsigned long 
flags;spin_lock_irqsave(&thread->lock,flags);z3ffe5a25a2(thread,entry);
spin_unlock_irqrestore(&thread->lock,flags);}static struct z27819d90ee*
z5f67dc7901(struct zc723a33f7c*thread){struct list_head*elem=thread->z44f09fd585
.next;struct z27819d90ee*entry=list_entry(elem,struct z27819d90ee,list);list_del
(&entry->list);return entry;}static struct z27819d90ee*z256896aa66(struct 
zc723a33f7c*thread){struct z27819d90ee*result;spin_lock_irq(&thread->lock);
result=z5f67dc7901(thread);spin_unlock_irq(&thread->lock);return result;}static 
void z6d79b39a5d(struct zc723a33f7c*thread){if(thread->options.zb2cdec2b3c)
thread->options.zb2cdec2b3c(thread->options.z5b953eb9a6);}static int z9b905e8b44
(struct z02665e35eb*page,void*data){struct zc723a33f7c*thread=(struct 
zc723a33f7c*)data;struct z27819d90ee*entry;z7749e224e4(zfa5cdab594,-1);entry=
kmem_cache_alloc(zfa5cdab594,GFP_KERNEL);if(!entry){z8be79bb9f5(
"ERROR: Unable to allocate memory in %s()",__func__);return-ENOMEM;}entry->
command=z936faf5bbe;entry->data=(void*)page;z7a37fba5bf(thread,entry);return 0;}
static void z43bcdf903a(struct zc723a33f7c*thread){struct z27819d90ee*entry;int 
result=0;z7749e224e4(zfa5cdab594,);entry=z256896aa66(thread);switch(entry->
command){case z589134ccf5:result=z0e321a71f8(thread->z9e05597b05,entry->
z874adccce4);break;case z936faf5bbe:result=z7c65b05520(thread->z9e05597b05,(
struct z02665e35eb*)entry->data);break;default:z8be79bb9f5(
"ERROR: Unknown command in %s()",__func__);BUG();}if(result)z6d79b39a5d(thread);
kmem_cache_free(zfa5cdab594,entry);}static void ze86dad1bf8(struct zc723a33f7c*
thread){while(!z94a5c55213(&thread->z44f09fd585))z43bcdf903a(thread);}static int
 z7fd27b9ca3(void*data){struct zc723a33f7c*thread=(struct zc723a33f7c*)data;
while(!kthread_should_stop()||!z94a5c55213(&thread->z44f09fd585)){
wait_event_interruptible(thread->zeddfb42eb7,!z94a5c55213(&thread->z44f09fd585)
||kthread_should_stop());if(z94a5c55213(&thread->z44f09fd585))continue;
z43bcdf903a(thread);}return 0;}struct zc723a33f7c*z3b40f7a090(struct z2f16773ac7
*options,struct block_device*bdev){unsigned int result;struct zc723a33f7c*thread
;z7749e224e4(zfa5cdab594,ERR_PTR(-1));thread=kmalloc(sizeof(*thread),GFP_KERNEL)
;if(!thread){z8be79bb9f5("ERROR: Can not allocate memory in %s()",__func__);
return ERR_PTR(-ENOMEM);}init_waitqueue_head(&thread->zeddfb42eb7);memcpy(&
thread->options,options,sizeof(*options));thread->z9e05597b05=zf1546d8ccb(
z9b905e8b44,(void*)thread,thread->options.z09b0ab5d86,thread->options.
z89bcebbeb9);if(IS_ERR(thread->z9e05597b05)){z8be79bb9f5(
"ERROR: Unable to create cl buffer [%d]",PTR_ERR(thread->z9e05597b05));result=
PTR_ERR(thread->z9e05597b05);goto z64a1c27c79;}INIT_LIST_HEAD(&thread->
z44f09fd585);spin_lock_init(&thread->lock);thread->task=kthread_run(z7fd27b9ca3,
thread,"%s-%u:%u",zbec9fe98c2,MAJOR(bdev->bd_dev),MINOR(bdev->bd_dev));if(IS_ERR
(thread->task)){z8be79bb9f5("ERROR: Unable to run kthread %s",zbec9fe98c2);
result=PTR_ERR(thread->task);goto zf69584e82e;}return thread;zf69584e82e:
z6f4ee1de48(thread->z9e05597b05);z64a1c27c79:kfree(thread);return ERR_PTR(result
);}void zc7c93d5adb(struct zc723a33f7c*thread){kthread_stop(thread->task);
ze86dad1bf8(thread);z6f4ee1de48(thread->z9e05597b05);kfree(thread);}int 
zf93edaa01a(struct zc723a33f7c*thread,sector_t addr){struct z27819d90ee*entry;
z7749e224e4(zfa5cdab594,-1);entry=kmem_cache_alloc(zfa5cdab594,GFP_KERNEL);if(!
entry){z8be79bb9f5("ERROR: Unable to allocate memory in %s()",__func__);
z6d79b39a5d(thread);return-ENOMEM;}entry->command=z589134ccf5;entry->z874adccce4
=addr;z22956b88fe(thread,entry);return 0;}
