/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#ifndef z2a4b228270
#define z2a4b228270
#include <linux/blkdev.h>
#include <linux/genhd.h>
#include <linux/version.h>
#include <linux/utsname.h>
#include "blksnap-config.h"
#define z6fe08bcedd	(LINUX_VERSION_CODE >= KERNEL_VERSION(5, 0, 0))
#if z6fe08bcedd
#  include <linux/blk-cgroup.h>
#endif
#define z783ee50611		(LINUX_VERSION_CODE <  KERNEL_VERSION(3, 16, 0))
#define zba53ee4d34	(LINUX_VERSION_CODE >= KERNEL_VERSION(2, 6, 33))
#if zba53ee4d34
#  include <generated/utsrelease.h>
#else
#  include <linux/utsrelease.h>
#endif
#define z4fd2eea979		(LINUX_VERSION_CODE >= KERNEL_VERSION(3, 2, 0 ))
#if z4fd2eea979
#  include <linux/export.h>
#endif
#ifndef z43b89c10f0
#  define z43b89c10f0 -20
#endif
#ifndef BIO_MAX_SIZE	
#  define BIO_MAX_SIZE BIO_MAX_PAGES << PAGE_SHIFT
#endif
#ifndef __UNIQUE_ID
# define ___PASTE(a,b) a##b
# define __PASTE(a,b) ___PASTE(a,b)
# define __UNIQUE_ID(prefix) __PASTE(__PASTE(__UNIQUE_ID_, prefix), __COUNTER__)
#endif
#if !HAVE_BIO_LIST
struct bio_list{struct bio*head;struct bio*tail;};static inline int 
bio_list_empty(const struct bio_list*bl){return bl->head==NULL;}static inline 
void bio_list_init(struct bio_list*bl){bl->head=bl->tail=NULL;}static inline 
void bio_list_add(struct bio_list*bl,struct bio*bio){bio->bi_next=NULL;if(bl->
tail)bl->tail->bi_next=bio;else bl->head=bio;bl->tail=bio;}static inline struct 
bio*bio_list_pop(struct bio_list*bl){struct bio*bio=bl->head;if(bio){bl->head=bl
->head->bi_next;if(!bl->head)bl->tail=NULL;bio->bi_next=NULL;}return bio;}
#endif 
#if !HAVE_BVEC_ITER
typedef int zfce99d4701;typedef struct bio_vec*z72affbf6ca;
#  define z6b5693e0ab(bio)		((bio)->bi_size)
#  define z9a3aa23558(bio)	((bio)->bi_sector)
#  define za0c02211c1(bio)		((bio)->bi_idx)
#  define za8c91e0f7a(bio, iter) \
	  ((bio)->bi_io_vec[(iter)].bv_len)
#  define zfde372e60c(bio, iter) \
	  ((bio)->bi_io_vec[(iter)].bv_offset)
#  define ze8ce909aac(bio, iter) \
	  ((bio)->bi_io_vec[(iter)].bv_page)
#  define ze0cf8f37bb(iter) (iter)
#  define z2e65fca973(z2780ebc3aa) (z2780ebc3aa->bv_page)
#  define z428df60e29(z2780ebc3aa) (z2780ebc3aa->bv_len)
#  define zf5d25860cd(z2780ebc3aa) (z2780ebc3aa->bv_offset)
#  define z04ddf3070e(bio) 
#else 
typedef struct bvec_iter zfce99d4701;typedef struct bio_vec z72affbf6ca;
#  define z6b5693e0ab(bio)		((bio)->bi_iter.bi_size)
#  define z9a3aa23558(bio)	((bio)->bi_iter.bi_sector)
#  define za0c02211c1(bio)		((bio)->bi_iter.bi_idx)
#  define za8c91e0f7a(bio, iter) \
	  bio_iter_len((bio), (iter))
#  define zfde372e60c(bio, iter) \
	  bio_iter_offset((bio), (iter))
#  define ze8ce909aac(bio, iter) \
	  bio_iter_page((bio), (iter))
#  define ze0cf8f37bb(iter) (iter.bi_idx)
#  define z2e65fca973(z2780ebc3aa) (z2780ebc3aa.bv_page)
#  define z428df60e29(z2780ebc3aa) (z2780ebc3aa.bv_len)
#  define zf5d25860cd(z2780ebc3aa) (z2780ebc3aa.bv_offset)
#  define z1ea77ba5d7	(LINUX_VERSION_CODE < KERNEL_VERSION(4, 2, 0))
#  if z1ea77ba5d7
#    define z04ddf3070e(bio) atomic_inc(&(bio)->bi_remaining)
#  else
#    define z04ddf3070e(bio) 
#  endif 
#endif 
#if !HAVE_BIO_HAS_DATA
static inline bool bio_has_data(struct bio*bio){if(bio&&bio->bi_vcnt)return true
;return false;}
#endif 
#if !defined(DISK_NAME_LEN)
#  define DISK_NAME_LEN 32
#endif
#if !HAVE_UTSNAME
static inline struct new_utsname*utsname(void){return&system_utsname;}
#endif
#if !defined(FLEX_ARRAY_FREE)
#  define FLEX_ARRAY_FREE 0x6c
#endif
#if BLKDEV_GET_2_ARGS
#  define z9e9250f2f1(bdev, mode)		blkdev_get(bdev, mode);
#elif BLKDEV_GET_3_ARGS
#  define z9e9250f2f1(bdev, mode)		blkdev_get(bdev, mode, 0);
#else
#  error\
 Cannot determine a type of blkdev_get() function. Contact developers please
#endif
#if BLKDEV_PUT_1_ARG
#  define zcc55cb1eef(bdev, mode)		blkdev_put(bdev);
#elif BLKDEV_PUT_2_ARGS
#  define zcc55cb1eef(bdev, mode)		blkdev_put(bdev, mode);
#else
#  error\
 Cannot determine a type of blkdev_put() function. Contact developers please
#endif
#if LOOKUP_BDEV_2_ARGS
#  define z0bf5aa5055(path)	lookup_bdev(path, 0)
#elif LOOKUP_BDEV_1_ARG
#  define z0bf5aa5055(path)	lookup_bdev(path)
#else
#  error\
 Cannot determine a type of lookup_bdev() function. Contact developers please
#endif
#if BIO_HAS_BI_STATUS
static const int z8219710930[]={[BLK_STS_OK]=0,[BLK_STS_NOTSUPP]=-EOPNOTSUPP,[
BLK_STS_TIMEOUT]=-ETIMEDOUT,[BLK_STS_NOSPC]=-ENOSPC,[BLK_STS_TRANSPORT]=-ENOLINK
,[BLK_STS_TARGET]=-EREMOTEIO,[BLK_STS_NEXUS]=-EBADE,[BLK_STS_MEDIUM]=-ENODATA,[
BLK_STS_PROTECTION]=-EILSEQ,[BLK_STS_RESOURCE]=-ENOMEM,[BLK_STS_AGAIN]=-EAGAIN,[
BLK_STS_DM_REQUEUE]=-EREMCHG,[BLK_STS_IOERR]=-EIO};static inline blk_status_t 
z27b5849382(int errno){int status;for(status=0;status<ARRAY_SIZE(z8219710930);
status++){if(z8219710930[status]==errno)return(__force blk_status_t)status;}
return BLK_STS_IOERR;}static inline int z5c82f6be4c(blk_status_t status){if((int
)status>=ARRAY_SIZE(z8219710930))return-EIO;return z8219710930[(int)status];}
#endif
#if BIO_HAS_BI_STATUS
#  define zb19cb4a80a(bio)		z5c82f6be4c(bio->bi_status)
#elif BIO_HAS_BI_ERROR
#  define zb19cb4a80a(bio)		(bio->bi_error)
#elif BIO_ENDIO_3_ARGS
#  define zb19cb4a80a(bio)		(z6b5693e0ab(bio) != 0)
#else
#  define zb19cb4a80a(bio)		(!test_bit(BIO_UPTODATE, &bio->bi_flags))
#endif
#if BIO_ENDIO_3_ARGS
static inline void z129afb1518(struct bio*bio,int err){bio_endio(bio,bio->
bi_size,err);}
#  define zde9db20bfc		int
#  define zed769d07ac			err
#  define zcedb2b06d7		err
#  define z4edcf500a0		struct bio *bio, \
					unsigned int z7a775ef162, \
					int err
#elif BIO_ENDIO_1_ARG
static inline void z129afb1518(struct bio*bio,int err){
#  if BIO_HAS_BI_STATUS
bio->bi_status=z27b5849382(err);
#  else
bio->bi_error=err;
#endif
bio_endio(bio);}
#  define zde9db20bfc		void
#  define zed769d07ac
#  define zcedb2b06d7		0
#  define z4edcf500a0		struct bio *bio
#elif BIO_ENDIO_2_ARGS
static inline void z129afb1518(struct bio*bio,int err){bio_endio(bio,err);}
#  define zde9db20bfc		void
#  define zed769d07ac
#  define zcedb2b06d7		err
#  define z4edcf500a0		struct bio *bio, int err
#else
#  error\
 Cannot determine a type of bio_endio() function. Contact developers please
#endif
#if BIO_SPLIT_2_ARGS
#  define z47a1d5b9cc(bio, z394ec8a073) \
	bio_split(bio, z394ec8a073)
#elif BIO_SPLIT_3_ARGS
#  define z47a1d5b9cc(bio, z394ec8a073)	\
	bio_split(bio, bio_split_pool, z394ec8a073)
#elif BIO_SPLIT_4_ARGS
#  define z47a1d5b9cc(bio, z394ec8a073) \
	bio_split(bio, z394ec8a073, GFP_NOIO, NULL)
#else
#  error\
 Cannot determine a type of bio_split() function. Contact developers please
#endif
#if SUBMIT_BIO_2_ARGS
#  define zc495e75f48(bio) \
	submit_bio(bio->bi_rw, bio)
#else
#  define zc495e75f48(bio) \
	submit_bio(bio)
#endif
#if BIO_HAS_BI_RW
#  define zb24ee97c39(bio, OP, zecad976e77)	\
	bio->bi_rw = OP | zecad976e77
#else
#  define zb24ee97c39(bio, OP, zecad976e77)	\
	bio_set_op_attrs(bio, OP, zecad976e77)
#endif
#if !HAVE_BLKDEV_GET_BY_PATH
static inline struct block_device*blkdev_get_by_path(const char*path,fmode_t 
mode,void*holder){struct block_device*bdev=lookup_bdev(path);int error;if(IS_ERR
(bdev))return bdev;error=z9e9250f2f1(bdev,mode);return error?ERR_PTR(error):bdev
;}
#endif
#ifndef bio_for_each_segment_all
#  define bio_for_each_segment_all(z13e9f4427a, bio, i) \
		for (i = 0, z13e9f4427a = (bio)->bi_io_vec; i < (bio)->bi_vcnt; i++, \
z13e9f4427a++)
#endif
#if !HAVE_BIO_FREE_PAGES
static inline void bio_free_pages(struct bio*bio){struct bio_vec*bvec;int i;
bio_for_each_segment_all(bvec,bio,i)__free_page(bvec->bv_page);}
#endif
#if !HAVE_BLK_QUEUE_MAX_HW_SECTORS
#  define blk_queue_max_hw_sectors(q, max_sectors) \
	blk_queue_max_sectors(q, max_sectors)
#endif
#if !HAVE_BLK_QUEUE_MAX_SEGMENTS
#  define blk_queue_max_segments(q, max_segments) \
	blk_queue_max_hw_segments(q, max_segments)
#endif
static inline void z796f4d2d79(struct request_queue*q){
#if z783ee50611
#elif HAVE_BLK_QUEUE_VIRT_BOUNDARY
blk_queue_virt_boundary(q,PAGE_SIZE-1);
#else
queue_flag_set_unlocked(QUEUE_FLAG_SG_GAPS,q);
#endif
}
#if !HAVE_BLK_SET_STACKING_LIMITS
#  define blk_set_stacking_limits(z4f65b3e887) \
	blk_set_default_limits(z4f65b3e887)
#endif
#if KMAP_ATOMIC_2_ARGS
#  define z9a2caebaa6(p)		kmap_atomic(p, KM_USER0)
#  define z2e75f4035e(a)	kunmap_atomic(a, KM_USER0)
#elif KMAP_ATOMIC_1_ARG
#  define z9a2caebaa6(p)		kmap_atomic(p)
#  define z2e75f4035e(a)	kunmap_atomic(a)
#else
#  error\
 Cannot determine a type of kmap_atomic() function. Contact developers please
#endif
#if MAKE_REQUEST_INT
#  define z76abdd5d38		int
#  define z010d94635b		ret
#  define z3209a39a11	ret =
#  define z49862b0790		0
#  define z802bc2b98b	z76abdd5d38 ret = z49862b0790
#elif MAKE_REQUEST_BLKQCT
#  define z76abdd5d38		blk_qc_t
#  define z010d94635b		ret
#  define z3209a39a11	ret =
#  define z49862b0790		BLK_QC_T_NONE
#  define z802bc2b98b	z76abdd5d38 ret = z49862b0790
#elif MAKE_REQUEST_VOID
#  define z76abdd5d38		void
#  define z010d94635b
#  define z3209a39a11
#  define z49862b0790
#  define z802bc2b98b
#else
#  error\
 Cannot determine a type of make_request() function. Contact developers please
#endif
#if ! HAVE_NOOP_LLSEEK
static inline loff_t noop_llseek(struct file*file,loff_t offset,int origin){
return file->f_pos;}
#endif
#if INT_THAW_BDEV
#  define z6b2616ddab	ret
#  define z3129c2eb7b		int ret = 0
#  define z9014c013e6	ret =
#else 
#  define z6b2616ddab	0
#  define z3129c2eb7b
#  define z9014c013e6
#endif
#if BDEV_OPEN_RELEASE_INODE
#  define	RELEASE_TYPE		int
#  define	z0fde54c0a4		0
#  define	z8ade56fb9e		struct inode *inode, struct file *file
#  define	z7a30256663	inode->i_bdev->bd_disk->private_data
#  define	z5bea0c8f4f		struct inode *inode, struct file *file
#  define	z6a5e38821b	z7a30256663
#  define	z5f1491e451		fmode_t mode = file->f_mode
#else
#  define	z8ade56fb9e		struct gendisk *disk, fmode_t mode
#  define	z7a30256663	disk->private_data
#  define	z5bea0c8f4f		struct block_device *bdev, fmode_t mode
#  define	z6a5e38821b	bdev->bd_disk->private_data
#  define	z5f1491e451
#  if BDEV_OPS_RELEASE_INT
#    define	RELEASE_TYPE		int
#    define	z0fde54c0a4		0
#  else
#    define	RELEASE_TYPE		void
#    define	z0fde54c0a4
#  endif
#endif
#ifndef READ_SYNC
#  define READ_SYNC		(READ | REQ_SYNC)
#endif
#ifndef WRITE_SYNC
#  define WRITE_SYNC		(WRITE | REQ_SYNC)
#endif
#ifndef SHA_MESSAGE_BYTES
#  define SHA_MESSAGE_BYTES (512 / 8)
#endif
#if !HAVE_SHA_INIT
static inline void zb4a569315f(__u32*buf){buf[0]=0x67452301;buf[1]=0xefcdab89;
buf[2]=0x98badcfe;buf[3]=0x10325476;buf[4]=0xc3d2e1f0;}
#else
#include <linux/cryptohash.h>
static inline void zb4a569315f(__u32*buf){sha_init(buf);}
#endif
#if BIO_HAS_BI_DISK
#  define z7dfb21d984(bio, bdev)	bio_set_dev(bio, bdev)
#if z6fe08bcedd
static inline void z101fbdec68(struct bio*bio){struct request_queue*q=bio->
bi_disk->queue;if(blkg_tryget(q->root_blkg))bio->bi_blkg=q->root_blkg;}
#define bio_associate_blkg z101fbdec68
#endif 
#  define z97c6426121(bio)		((bio)->bi_disk->queue)
#else
#  define z7dfb21d984(bio, bdev)	(bio->bi_bdev = bdev)
#  define z97c6426121(bio)		bdev_get_queue((bio)->bi_bdev)
#endif 
#endif 

