/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/types.h>
#include <linux/gfp.h>
#include <linux/slab.h>
#include <linux/kernel.h>
#include <linux/blkdev.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-data.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-extent.h"
#define z50335e8223	(0xdeadbeef)
struct z8c55b3fba3*z6e59e5b808(struct block_device*bdev){gfp_t gfp_mask=GFP_NOIO
;struct z8c55b3fba3*store;store=kzalloc(sizeof(*store),gfp_mask);if(!store)
return ERR_PTR(-ENOMEM);store->bdev=bdev;mutex_init(&store->extents.lock);
mutex_init(&store->ze293e16932);return store;}void z7d0bb18391(struct 
z8c55b3fba3*store){if(!store)return;z1acc38b162(store->extents.head);kfree(store
);}bool ze2638cd99c(struct z8c55b3fba3*store){return(store&&store->valid);}void 
ze9df4351d7(struct z8c55b3fba3*store){z5769993871(store->bdev,
"Data store utilization (memory: %llu/%llu, disk: %llu/%llu)",store->z9a097fb66a
,store->z82ac795f63,store->zb258f5f253,store->z70407d59e2);store->z9a097fb66a=
store->zb258f5f253=0;}int z99fa386529(struct z8c55b3fba3*store){mutex_lock(&
store->ze293e16932);store->valid=false;ze9df4351d7(store);z1acc38b162(store->
extents.head);store->extents.head=NULL;store->z82ac795f63=store->z70407d59e2=0;
mutex_unlock(&store->ze293e16932);return 0;}int z15d6091fb8(struct z8c55b3fba3*
store,struct z87953c6ebf*map){unsigned int i;struct z718cdad054*new;if(
ze79cbbfa4a(map)){if(store->z82ac795f63>0||store->z70407d59e2>0){z5769993871(
store->bdev,"WARNING: Attempt to map already mapped data store");return-EEXIST;}
store->z82ac795f63=map->npages;}for(i=0;i<map->z473eb14421;i++){new=z76133370d0(
map->extents[i].start_sect,map->extents[i].z049dd48065,store->extents.head);if(
IS_ERR(new))return PTR_ERR(new);store->extents.head=new;store->z70407d59e2+=map
->extents[i].z049dd48065>>zf0d12088d2;}if(zdc056c7b40(map)){zecd82a79ce(store->
extents.head,store->bdev,"data");z5769993871(store->bdev,
"Data store is mapped (memory: %llu, disk: %llu)",store->z82ac795f63,store->
z70407d59e2);store->valid=true;}return 0;}int z3efcafecaa(struct z8c55b3fba3*
store,struct z9a6dff1010*z607b17d5a3){int err=0;mutex_lock(&store->ze293e16932);
if(store->z9a097fb66a<store->z82ac795f63){store->z9a097fb66a++;z607b17d5a3->page
=(struct page*)z50335e8223;D("+L  M (0x%p)",z607b17d5a3);goto out;}if(store->
zb258f5f253<store->z70407d59e2){if(zcc9f3027ef(store->extents.head,z7be15aefe1*
store->zb258f5f253,z7be15aefe1,&z607b17d5a3->zac0b00e018)){store->zb258f5f253++;
D("+L  D (0x%p, %llu)",z607b17d5a3,z607b17d5a3->zac0b00e018);goto out;}}err=-
ENOSPC;out:mutex_unlock(&store->ze293e16932);return err;}static inline bool 
z6c3adefcfe(struct z9a6dff1010*z607b17d5a3){return(z607b17d5a3->page&&
z607b17d5a3->page!=(struct page*)z50335e8223&&z607b17d5a3->committed);}static 
inline bool z985526475e(struct z9a6dff1010*z607b17d5a3){return(z607b17d5a3->
committed&&z607b17d5a3->page==NULL);}static inline bool z21d3853983(struct 
z9a6dff1010*z607b17d5a3){return z6c3adefcfe(z607b17d5a3)||z985526475e(
z607b17d5a3);}bool zfce2568dba(struct z9a6dff1010*z607b17d5a3){bool has_data;
unsigned long flags;read_lock_irqsave(&z607b17d5a3->lock,flags);has_data=
z21d3853983(z607b17d5a3);read_unlock_irqrestore(&z607b17d5a3->lock,flags);return
 has_data;}void z995151952a(struct z9a6dff1010*z607b17d5a3){struct page*page;
page=z607b17d5a3->page;z607b17d5a3->page=NULL;put_page(page);z607b17d5a3->
committed=true;}void z9bf979875f(struct z9a6dff1010*z607b17d5a3){unsigned long 
flags;write_lock_irqsave(&z607b17d5a3->lock,flags);z995151952a(z607b17d5a3);
write_unlock_irqrestore(&z607b17d5a3->lock,flags);}void zff4c021f5e(struct 
z9a6dff1010*z607b17d5a3){D("-L  %c (0x%p, %llu, 0x%p)",z6c3adefcfe(z607b17d5a3)?
'M':'D',z607b17d5a3,z607b17d5a3->zac0b00e018,z607b17d5a3->page);if(z6c3adefcfe(
z607b17d5a3)){struct page*page;page=z607b17d5a3->page;z607b17d5a3->page=NULL;
put_page(page);}z607b17d5a3->committed=false;}void zba10cc4230(struct 
z9a6dff1010*z607b17d5a3){unsigned long flags;write_lock_irqsave(&z607b17d5a3->
lock,flags);zff4c021f5e(z607b17d5a3);write_unlock_irqrestore(&z607b17d5a3->lock,
flags);}void z8468609e4a(struct z9a6dff1010*z607b17d5a3){unsigned long flags;
read_lock_irqsave(&z607b17d5a3->lock,flags);z8be79bb9f5(
" L  (0x%p, %llu) committed: %s, page: 0x%p",z607b17d5a3,z607b17d5a3->
zac0b00e018,(z607b17d5a3->committed)?"yes":"no",z607b17d5a3->page);
read_unlock_irqrestore(&z607b17d5a3->lock,flags);}static sector_t zfad23bb767(
struct z8c55b3fba3*store,struct z9a6dff1010*z607b17d5a3){return z43b8ce200c(
store->extents.head,z607b17d5a3->zac0b00e018);}static bool zd6103a1af9(struct 
z8c55b3fba3*store,struct z9a6dff1010*z607b17d5a3,struct bio*bio){z607b17d5a3->
committed=false;zb24ee97c39(bio,WRITE,0);z9a3aa23558(bio)=zfad23bb767(store,
z607b17d5a3);z607b17d5a3->page=bio_page(bio);D(" L  D >>> %llu (0x%p, %llu)",
z9a3aa23558(bio),z607b17d5a3,z607b17d5a3->zac0b00e018);return false;}static bool
 z01020cec43(struct z9a6dff1010*z607b17d5a3,struct bio*bio){z607b17d5a3->page=
bio_page(bio);z607b17d5a3->committed=true;D(" L  M >>> %llu (0x%p, 0x%p)",
z9a3aa23558(bio),z607b17d5a3,z607b17d5a3->page);return true;}bool z29b49eca83(
struct z8c55b3fba3*store,struct z9a6dff1010*z607b17d5a3,struct bio*bio,int*err){
bool completed;unsigned long flags;if(zb1d2e81594(z607b17d5a3,__func__)){*err=-
EINVAL;return true;}write_lock_irqsave(&z607b17d5a3->lock,flags);if(z21d3853983(
z607b17d5a3)){z5769993871(store->bdev,
"WARNING: Attempt to put already valid cow_blk");completed=true;*err=-EINVAL;
goto out;}completed=(z607b17d5a3->page?z01020cec43(z607b17d5a3,bio):zd6103a1af9(
store,z607b17d5a3,bio));*err=0;out:write_unlock_irqrestore(&z607b17d5a3->lock,
flags);return completed;}static bool zda1f1f51ad(struct z8c55b3fba3*store,struct
 z9a6dff1010*z607b17d5a3,struct bio*bio){sector_t start,offset;offset=
z9a3aa23558(bio)-zc145183281(bio);start=zfad23bb767(store,z607b17d5a3);D(
" L  REMAP %llu -> %llu (+%llu)",z9a3aa23558(bio),start,offset);z9a3aa23558(bio)
=start+offset;return false;}static bool z04b837ecae(struct z9a6dff1010*
z607b17d5a3,struct bio*bio){sector_t start_sect,z8afdc2338d;char*z24ab91c41a,*
z7b51c6cfb4;z72affbf6ca z2780ebc3aa;zfce99d4701 iter;unsigned int z88d87d1f51,
z81e765b111,zff9f447dca;start_sect=zc145183281(bio);z8afdc2338d=z9a3aa23558(bio)
-start_sect;z7b51c6cfb4=z9a2caebaa6(z607b17d5a3->page);z88d87d1f51=z8afdc2338d<<
SECTOR_SHIFT;bio_for_each_segment(z2780ebc3aa,bio,iter){z81e765b111=zfde372e60c(
bio,iter);zff9f447dca=za8c91e0f7a(bio,iter);z24ab91c41a=z9a2caebaa6(ze8ce909aac(
bio,iter));memcpy(z24ab91c41a+z81e765b111,z7b51c6cfb4+z88d87d1f51,zff9f447dca);
z2e75f4035e(z24ab91c41a);z88d87d1f51+=zff9f447dca;}z2e75f4035e(z7b51c6cfb4);D(
" L  M <<< %llu (0x%p, 0x%p) [%u, +%llu]",start_sect,z607b17d5a3,z607b17d5a3->
page,z6b5693e0ab(bio),z8afdc2338d);return true;}bool zff39f745be(struct 
z8c55b3fba3*store,struct z9a6dff1010*z607b17d5a3,struct bio*bio,int*err){bool 
completed;unsigned long flags;if(zb1d2e81594(z607b17d5a3,__func__)){*err=-EINVAL
;return true;}read_lock_irqsave(&z607b17d5a3->lock,flags);if(!z21d3853983(
z607b17d5a3)){z5769993871(store->bdev,"WARNING: attempt to get invalid cow_blk")
;completed=true;*err=-EINVAL;goto out;}completed=(z6c3adefcfe(z607b17d5a3)?
z04b837ecae(z607b17d5a3,bio):zda1f1f51ad(store,z607b17d5a3,bio));*err=0;out:
read_unlock_irqrestore(&z607b17d5a3->lock,flags);return completed;}
