/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/fs.h>
#include <linux/slab.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/blkdev.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-extent.h"
#define zf46824a71b(z40fb4bc695, xt) for ((xt) = (z40fb4bc695); (xt) && ((xt)->\
z049dd48065); (xt) = (xt)->next)
static struct kmem_cache*z9f2d11b056=NULL;int z3e71cc6cc0(void){if(unlikely(
z9f2d11b056)){WARN(1,"Detected try to re-create a cache, %s",__func__);return-
EEXIST;}z9f2d11b056=KMEM_CACHE(z718cdad054,0);if(!z9f2d11b056){z8be79bb9f5(
"ERROR: Can't create cache in %s",__func__);return-ENOMEM;}return 0;}void 
za8a159e650(void){if(unlikely(!z9f2d11b056)){WARN(1,
"Detected try to destroy an empty cache, %s",__func__);return;}
kmem_cache_destroy(z9f2d11b056);z9f2d11b056=NULL;}static struct z718cdad054*
zb6cf94a431(void){gfp_t gfp_mask=GFP_KERNEL;struct z718cdad054*ext;z7749e224e4(
z9f2d11b056,NULL);ext=kmem_cache_alloc(z9f2d11b056,gfp_mask);return ext;}static 
void z0f4e9223de(struct z718cdad054*ext){BUG_ON(!ext);z7749e224e4(z9f2d11b056,);
kmem_cache_free(z9f2d11b056,ext);}static struct z718cdad054*zfc75bed9f3(sector_t
 start,size_t z049dd48065,struct z718cdad054*next){struct z718cdad054*ext=
zb6cf94a431();if(!ext)return ERR_PTR(-ENOMEM);ext->z049dd48065=z049dd48065;ext->
start=start;ext->next=next;return ext;}static bool z488b2c90ee(struct 
z718cdad054*ext,sector_t start,u32 z049dd48065){return!(ext->start+ext->
z049dd48065<start||start+z049dd48065<ext->start);}static bool za847496246(
sector_t start,size_t z049dd48065,struct z718cdad054*ext){BUG_ON(!ext);return((
start+z049dd48065)<ext->start);}static void z0163f5f82f(struct z718cdad054*start
,struct z718cdad054*end){if(!start)return;if(start==end){z0f4e9223de(start);
return;}while(start!=end){struct z718cdad054*ext=start;start=start->next;
z0f4e9223de(ext);}}struct z718cdad054*z76133370d0(sector_t start,size_t 
z049dd48065,struct z718cdad054*head){struct z718cdad054*tmp,*prev,*next,*new;if(
(!start&&head)||!z049dd48065){z8be79bb9f5(
"WARNING: try to add invalid extent (0x%p, %llu, %llu)",head,start,z049dd48065);
return head;}D(" E add: %llu +%u (0x%p)",start,z049dd48065,head);if(!head||
za847496246(start,z049dd48065,head)){new=zfc75bed9f3(start,z049dd48065,head);if(
IS_ERR(new))goto no_memory;return new;}for(tmp=head,prev=NULL;tmp&&(start>tmp->
start+tmp->z049dd48065);prev=tmp,tmp=tmp->next);for(next=tmp;next&&next->next&&(
start+z049dd48065>=next->next->start);prev=next,next=next->next);if(tmp&&
z488b2c90ee(tmp,start,z049dd48065)){struct z718cdad054*foo=tmp->next;u64 
z118096f5ca;tmp->start=MIN(start,tmp->start);z118096f5ca=MAX(start+z049dd48065,
next->start+next->z049dd48065)-tmp->start;if(tmp!=next)z0163f5f82f(foo,next->
next);if(SIZE_MAX<z118096f5ca){tmp->z049dd48065=SIZE_MAX;new=zfc75bed9f3(tmp->
z049dd48065+SIZE_MAX,z118096f5ca-SIZE_MAX,next->next);if(IS_ERR(new))goto 
no_memory;tmp->next=new;}else{tmp->z049dd48065=z118096f5ca;tmp->next=next->next;
}}else{new=zfc75bed9f3(start,z049dd48065,tmp);if(IS_ERR(new))goto no_memory;prev
->next=new;}return head;no_memory:z8be79bb9f5(
"FATAL: Can't allocate memory for new extent");return ERR_PTR(-ENOMEM);}sector_t
 z43b8ce200c(struct z718cdad054*head,sector_t offset){sector_t zef7b339f03=0;
struct z718cdad054*ext;zf46824a71b(head,ext){if(offset>=zef7b339f03&&offset<
zef7b339f03+ext->z049dd48065)return ext->start+(offset-zef7b339f03);zef7b339f03
+=ext->z049dd48065;}return 0;}int zcc9f3027ef(struct z718cdad054*head,sector_t 
start,size_t z049dd48065,sector_t*addr){sector_t zef7b339f03=0;struct 
z718cdad054*xt,*x;D("(%s) start %llu, len %u",__func__,start,z049dd48065);BUG_ON
(!head);zf46824a71b(head,xt){D("(%s) looking at %llu, in (%llu,%u)",__func__,
zef7b339f03,xt->start,xt->z049dd48065);if(start>=zef7b339f03&&start<zef7b339f03+
xt->z049dd48065){if(z049dd48065<=xt->z049dd48065-(start-zef7b339f03)){*addr=
start;return 1;}else{zef7b339f03+=xt->z049dd48065;break;}}zef7b339f03+=xt->
z049dd48065;}if(!xt){z8be79bb9f5(
"WARNING: Size of extent map %p is smaller than should",head);return 0;}
zf46824a71b(xt->next,x){if(x->z049dd48065>=z049dd48065){*addr=zef7b339f03;return
 1;}zef7b339f03+=x->z049dd48065;}return 0;}void z1acc38b162(struct z718cdad054*
head){z0163f5f82f(head,NULL);}
#if defined(zb36d4c4d31)
void zecd82a79ce(const struct z718cdad054*head,const struct block_device*bdev,
const char*type){z5769993871(bdev,"%s extents:",type);for(;head;head=head->next)
z8be79bb9f5(" E (%llu +%u) 0x%p -> 0x%p",head->start,head->z049dd48065,head,head
->next);}
#else 
void zecd82a79ce(const struct z718cdad054*head,const struct block_device*bdev,
const char*type){return;}
#endif 

