/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/blkdev.h>
#include <linux/delay.h>
#include <linux/reboot.h>
#include <linux/slab.h>
#include <linux/miscdevice.h>
#include <linux/fs.h>
#include <linux/bio.h>
#include <linux/mm_types.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-bio-queue.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-fs-types.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-main.h"
#include "blksnap-data.h"
#include "blksnap-cow-tree.h"
#include "blksnap-extent.h"
#include "blksnap-cl-store.h"
#include "blksnap-write-queue.h"
#include "blksnap-snapshot.h"
#include "blksnap-device-utils.h"
#include "blksnap-volume.h"
#include "blksnap-bio-submit.h"
#include "blksnap-metadata.h"
#include "blksnap-bitmap.h"
#include "version.h"
#ifndef z300c963fae
#  define z300c963fae	"Proprietary"
#endif
#define z6be5024153			"Quest Software Inc."
#define LICENSE			z300c963fae
#define zd862ce83df		(FMODE_READ)
#define zdbcb3682e7	15
#define z786c86bccb	200
#define z6e5728f541	100
static int disabled=0;module_param(disabled,int,0444);MODULE_PARM_DESC(disabled,
"Disable this module completely");static char*devices=NULL;module_param(devices,
charp,0444);MODULE_PARM_DESC(devices,"A comma separated list of block devices");
static DEFINE_MUTEX(z6d663f46bd);static atomic_t zfa0617b68b;static char*
z5d97114935=UTS_RELEASE;static atomic_t destroyed;static int zb1d954174a(struct 
bio*bio){return((bio_data_dir(bio)==WRITE)&&bio_has_data(bio));}bool z88e86404d3
(struct page*page){bool ret=false;uint64_t*buf=z9a2caebaa6(page);if(z0eea31ba3c
==*buf)ret=true;z2e75f4035e(buf);return ret;}int zc3cb76f49b(struct bio*bio,
struct z4964f1d5f4*volume){sector_t curr;unsigned int mapped=0;zfce99d4701 iter;
z72affbf6ca bvec;curr=z9a3aa23558(bio);bio_for_each_segment(bvec,bio,iter){int 
ret=1;unsigned int z049dd48065=sector_count(za8c91e0f7a(bio,iter));if(!
z88e86404d3(ze8ce909aac(bio,iter)))continue;mutex_lock(&volume->z51b17b1918.lock
);if(likely(volume&&zd4ec020f4e(volume))){ret=zd128d92689(curr,z049dd48065,&
volume->z51b17b1918);}mutex_unlock(&volume->z51b17b1918.lock);mapped++;if(ret){
z0e96e5b5b4(volume,"ERROR: Can't add extent [%lu:%u]",curr,SECTOR_SIZE);break;}
curr+=z049dd48065;}return mapped;}static z76abdd5d38 z3a18f09fb9(struct 
request_queue*q,struct bio*bio){struct z3fc80aee23*bd=z699562bcf3(bio);
make_request_fn*zb9060ff5bc;struct request_queue*queue;z802bc2b98b;BUG_ON(!bd);
zb9060ff5bc=bd->zb9060ff5bc;queue=bdev_get_queue(bd->bdev);if(zb1d954174a(bio)&&
!zbda1a0e156(bio)){struct z4964f1d5f4*volume=z90c0a440b9(bd,z9a3aa23558(bio));if
(unlikely(!volume)){D(" X  %llu 0x%p",z9a3aa23558(bio),bio);goto zb9060ff5bc;}if
(zd4ec020f4e(volume)){int mapped=0;mapped=zc3cb76f49b(bio,volume);if(mapped){
z129afb1518(bio,0);goto out;}}D("@@@ %llu (%llu)  W  %u [%s]",zc145183281(bio),
z9a3aa23558(bio),z6b5693e0ab(bio),current->comm);if(z45520bb515(volume)){
z3e19885666(volume,bio);goto out;}if(test_bit(zacc33700d8,&volume->flags)&&
test_bit(z2f9b7fc0d8,&volume->flags))goto zb9060ff5bc;z3bfa674a26(volume,bio);}
WARN_ON(bio->bi_next);zb9060ff5bc:z3209a39a11 zb9060ff5bc(queue,bio);out:return 
z010d94635b;}static void zf5f2de32fd(struct z3fc80aee23*disk){struct 
request_queue*q=bdev_get_queue(disk->bdev);disk->zb9060ff5bc=xchg(&q->
make_request_fn,z3a18f09fb9);}static const char*z888728dd09(enum ze1b0429435 
fs_type){int zfb6d51e636;static char*unknown="unknown";const char*ret=unknown;
for(zfb6d51e636=0;zfb6d51e636<sizeof(z5ede1346d9)/sizeof(struct zb1b4bdd5e4);
zfb6d51e636++){if(fs_type==z5ede1346d9[zfb6d51e636].fs_type){ret=z5ede1346d9[
zfb6d51e636].name;break;}}return ret;}static struct z3fc80aee23*z5176dd586b(
struct block_device*bdev){struct z3fc80aee23*device;if(!bdev||!bdev->bd_disk)
return NULL;device=kzalloc(sizeof(*device),GFP_KERNEL);if(!device)return ERR_PTR
(-ENOMEM);mutex_init(&device->lock);INIT_LIST_HEAD(&device->volumes);device->
bdev=bdev;list_add_tail(&device->siblings,&z4722baef3a);zf5f2de32fd(device);
z5769993871(device->bdev,"Disk is attached");return device;}
#define z03b27dd331	(-1)
static struct z4964f1d5f4*zf816783829(struct block_device*bdev,const char*name){
int z0a133a52cb;gfp_t gfp_mask=GFP_KERNEL;struct z4964f1d5f4*volume;volume=
kzalloc(sizeof(*volume),gfp_mask);if(!volume)return ERR_PTR(-ENOMEM);volume->
bdev=bdev;volume->ze190bba191=RB_ROOT;volume->id=z03b27dd331;volume->
start_sector=get_start_sect(volume->bdev);volume->start_block=z0756660e7b(volume
->start_sector);z0a133a52cb=za4f36df3d0(volume);if(z0a133a52cb)goto zf28a40dc16;
init_rwsem(&volume->za087258663);mutex_init(&volume->z51b17b1918.lock);
mutex_init(&volume->z0f9dc72af9);atomic_set(&volume->z939954fbe1,0);z2671aaaf2e(
volume);strncpy(volume->name,name,z0bc451b5a6);set_bit(zacc33700d8,&volume->
flags);clear_bit(zb4978ba7ae,&volume->flags);return volume;zf28a40dc16:kfree(
volume);return ERR_PTR(z0a133a52cb);}static void z522924ec73(struct z3fc80aee23*
disk);static int z3628a67cbe(struct z3628a67cbe*attach){int res=0;int 
z66bc8d3488;struct block_device*bdev;struct z3fc80aee23*disk;struct z4964f1d5f4*
volume=NULL;char*path=attach->name;struct z718cdad054*new;bdev=
blkdev_get_by_path(path,zd862ce83df,NULL);if(IS_ERR(bdev))return PTR_ERR(bdev);
volume=z2ee27eb651(bdev);if(volume){zcc55cb1eef(bdev,zd862ce83df);return-EEXIST;
}if(zc45979d9d3(bdev)){zcc55cb1eef(bdev,zd862ce83df);return-EINVAL;}volume=
zf816783829(bdev,path);if(IS_ERR(volume)){zcc55cb1eef(bdev,zd862ce83df);
z5769993871(bdev,"ERROR: failed to allocate volume");return PTR_ERR(volume);}
z2d3d3ecb44(bdev);volume->data=z6e59e5b808(volume->bdev);if(IS_ERR(volume->data)
){z0e96e5b5b4(volume,"ERROR: Failed to create COW store");res=PTR_ERR(volume->
data);goto err;}volume->zc8e6cc3a13=z11f0a50e6f(volume->bdev);if(IS_ERR(volume->
zc8e6cc3a13)){z0e96e5b5b4(volume,"ERROR: Failed to create CL store");res=PTR_ERR
(volume->zc8e6cc3a13);goto z4002a04dae;}disk=z1190fce1c5(bdev->bd_contains);if(!
disk)disk=z5176dd586b(bdev->bd_contains);if(!disk||IS_ERR(disk)){z0e96e5b5b4(
volume,"ERROR: Failed to attach disk");res=-EFAULT;goto z49d015acc6;}volume->
device=disk;volume->id=atomic_add_return(1,&zfa0617b68b)-1;volume->zd43db139a0=
attach->zd43db139a0;z0e96e5b5b4(volume,"FileSystem is: %s",z888728dd09(volume->
zd43db139a0));mutex_init(&volume->metadata.extents.lock);for(z66bc8d3488=0;
z66bc8d3488<attach->z473eb14421;z66bc8d3488++){new=z76133370d0(attach->
zbdd3160c2c[z66bc8d3488].start_sect,attach->zbdd3160c2c[z66bc8d3488].z049dd48065
,volume->metadata.zbdd3160c2c);if(IS_ERR(new)){z0e96e5b5b4(volume,
"ERROR: failed to add hasblocks extent");goto z5a3d395c1c;}volume->metadata.
zbdd3160c2c=new;z0e96e5b5b4(volume,"Add hashblocks extent #%d [%lu, %lu]",
z66bc8d3488,attach->zbdd3160c2c[z66bc8d3488].start_sect,attach->zbdd3160c2c[
z66bc8d3488].z049dd48065);}z5c980244f9(bdev,&volume->metadata);if((attach->flags
&z77442dc426)||z771644cc39(bdev)){set_bit(zb4978ba7ae,&volume->flags);
z0e96e5b5b4(volume,"WARNING: volume is mounted in RW mode");}if(attach->flags&
z9c32ae976a)set_bit(z55f91a65ec,&volume->fs_flags);list_add_tail(&volume->
siblings,&disk->volumes);list_add_tail(&volume->z1f72606673,&z5c61784474);
z0e96e5b5b4(volume,"Volume is attached");out:return res;z5a3d395c1c:z1acc38b162(
volume->metadata.zbdd3160c2c);if(volume->device&&list_empty(&volume->device->
volumes))z522924ec73(volume->device);z49d015acc6:if(volume->zc8e6cc3a13&&!IS_ERR
(volume->zc8e6cc3a13))kfree(volume->zc8e6cc3a13);z4002a04dae:if(volume->data&&!
IS_ERR(volume->data))kfree(volume->data);err:zfc4aa97619(bdev);zcc55cb1eef(bdev,
zd862ce83df);z6915182530(volume);kfree(volume);goto out;}static void z9fdae29cbe
(struct z3fc80aee23*disk){struct request_queue*q=bdev_get_queue(disk->bdev);(
void)xchg(&q->make_request_fn,disk->zb9060ff5bc);}static void z522924ec73(struct
 z3fc80aee23*disk){z9fdae29cbe(disk);z5769993871(disk->bdev,"Disk is detached");
list_del(&disk->siblings);kfree(disk);}static int z1968ea0bb1(struct z4964f1d5f4
*volume){int zf4cfa75736=zd9c36f385d;if(z03c66388ea(volume->zc8e6cc3a13)==
zdac4bfcb2a)return-EBUSY;if(z65f8f023c9(volume->zc8e6cc3a13)&&!test_bit(
zacc33700d8,&volume->flags)){if(z3fe028ac5a(volume))zf4cfa75736=zc67824176f;else
 zf4cfa75736=zb529f94ecc;}else{zf4cfa75736=zc67824176f;}update_metadata(volume,
zf4cfa75736);list_del(&volume->z1f72606673);list_del(&volume->siblings);
z7d0bb18391(volume->data);if(volume->device&&list_empty(&volume->device->volumes
))z522924ec73(volume->device);z6915182530(volume);z1acc38b162(volume->metadata.
extents.head);z1acc38b162(volume->metadata.zbdd3160c2c);z143c8e7765(volume->
zc8e6cc3a13);volume->zc8e6cc3a13=NULL;clear_bit(z857b62ec9f,&volume->flags);
mutex_lock(&volume->z51b17b1918.lock);z1acc38b162(volume->z51b17b1918.head);
mutex_unlock(&volume->z51b17b1918.lock);z0e96e5b5b4(volume,"Volume is detached")
;zfc4aa97619(volume->bdev);zcc55cb1eef(volume->bdev,zd862ce83df);kfree(volume);
return 0;}static int z957bf26383(struct z4964f1d5f4*volume){int ret=0;do{if(ret
!=0)msleep(z6e5728f541);if(volume->disk)z48894a7ef3(volume,true);ret=z1968ea0bb1
(volume);}while(ret==-EBUSY);return ret;}static int z32cb0cc233(struct 
z32cb0cc233*detach){struct z4964f1d5f4*volume;volume=z17ef5db9c9(detach->name);
if(!volume)return-ENODEV;if(volume->disk)return-zad1d493a6b;return z1968ea0bb1(
volume);}static void zdfd4166920(struct z4964f1d5f4*volume,struct zd0f9e4ae25*
bid){if(test_bit(zacc33700d8,&volume->flags))bid->flags|=z11ebdae584;if(
z65f8f023c9(volume->zc8e6cc3a13))bid->flags|=z3c2af8a310;if(volume->metadata.
extents.head)bid->flags|=z5d44ab3c92;if(ze2638cd99c(volume->data))bid->flags|=
zbcdc93b2e5;if(zed315d8bae(volume))bid->flags|=zda8806f1e0;memcpy(bid->name,
volume_name(volume),z0bc451b5a6);if(volume->device&&volume->device->bdev&&volume
->device->bdev->bd_disk){char buf[BDEVNAME_SIZE];const char*buf_ptr;size_t 
z0aa9cc82df;buf_ptr=zbdd2b96058(volume->device,buf);z0aa9cc82df=min3((size_t)(
strlen(buf_ptr)+1),(size_t)BDEVNAME_SIZE,(size_t)z0bc451b5a6);memcpy(bid->
device_name,buf_ptr,z0aa9cc82df);}if(volume->disk)memcpy(bid->z8a8bb75131,
z4719007b5e(volume),z0bc451b5a6);if(volume->link.to)memcpy(bid->zd202e79b8a,
volume_name(volume->link.to),z0bc451b5a6);}static int z038c9aa62a(struct 
zd0f9e4ae25*device){struct z4964f1d5f4*volume;volume=z17ef5db9c9(device->name);
if(!volume)return-ENODEV;zdfd4166920(volume,device);return 0;}static int 
z5b91bfbc4a(struct z5b91bfbc4a*list){int ret=0;unsigned int count=0;struct 
list_head*p,*q;list_for_each_safe(p,q,&z5c61784474){count++;}if(list->
z18b77d1866==zfe2a814bcb||count==0){list->z18b77d1866=count;return ret;}if(list
->z18b77d1866!=count){return-EAGAIN;}count=0;list_for_each_safe(p,q,&z5c61784474
){struct z4964f1d5f4*volume=list_entry(p,struct z4964f1d5f4,z1f72606673);
zdfd4166920(volume,&list->devices[count]);count++;}list->z18b77d1866=count;
return ret;}static int z06f5205de4(struct z4964f1d5f4*volume){if(!volume||!
volume->device)return-ENODEV;if(!volume->bdev->bd_disk)return-ENODEV;if(volume->
disk)return-zad1d493a6b;return 0;}static int z6008314d8b(struct z6008314d8b*
start){int err;struct z4964f1d5f4*volume;bool zd5c1b6aeef;volume=z17ef5db9c9(
start->name);err=z06f5205de4(volume);if(err)return err;if(z03c66388ea(volume->
zc8e6cc3a13)==zdac4bfcb2a)return-EBUSY;if(!ze2638cd99c(volume->data))return-
z2a92ef1fb2;zd5c1b6aeef=test_bit(z55f91a65ec,&volume->fs_flags);if(!zd5c1b6aeef)
{if(IS_ERR(z2c0cb1aa81(volume))){z0e96e5b5b4(volume,
"ERROR: failed to freeze filesystem");return-ENXIO;}}z0e96e5b5b4(volume,
"Starting snapshot...");update_metadata(volume,zb529f94ecc);err=z35e8447306(
volume,start);update_metadata(volume,zc67824176f);if(!zd5c1b6aeef){if(
ze9c7b9d72d(volume)){z0e96e5b5b4(volume,"ERROR: failed to thaw filesystem");err=
-ENXIO;}}if(err)return err;memcpy(start->z8a8bb75131,z4719007b5e(volume),
z0bc451b5a6);return 0;}static int zc0749aa884(struct zc0749aa884*stop){struct 
z4964f1d5f4*volume;volume=z17ef5db9c9(stop->name);if(!volume||!volume->device)
return-ENODEV;if(!volume->disk)return-zb564944998;if(atomic_read(&volume->
z939954fbe1)>0)return-EBUSY;z0e96e5b5b4(volume,"Stopping snapshot...");return 
z48894a7ef3(volume,stop->merge!=0);}static int zce1ec578d2(struct zce1ec578d2*
show){struct z4964f1d5f4*volume;volume=z17ef5db9c9(show->name);if(!volume||!
volume->device)return-ENODEV;if(!volume->disk)return-zb564944998;memcpy(show->
z8a8bb75131,z4719007b5e(volume),z0bc451b5a6);if(volume->link.to)memcpy(show->
zd202e79b8a,volume_name(volume->link.to),z0bc451b5a6);return 0;}static void 
z33d48fe8bf(struct z4964f1d5f4*volume,struct zb7b929fc6a*z2c7222ab3c){sector_t 
offset=0;if(z2c7222ab3c->offset)offset=volume->start_block+z2c7222ab3c->offset+1
;z2c7222ab3c->z473eb14421=z3e7800bfb2(volume,z2c7222ab3c->extents,z2c7222ab3c->
z473eb14421,offset);}static int zb7b929fc6a(struct zb7b929fc6a*z2c7222ab3c){
struct z4964f1d5f4*volume;volume=z17ef5db9c9(z2c7222ab3c->name);if(!volume)
return-ENODEV;if(test_bit(zacc33700d8,&volume->flags))return-z76972b287e;if(
z2c7222ab3c->z473eb14421==0){if(z2c7222ab3c->offset!=0)return-EFAULT;z2c7222ab3c
->nblocks=z099115335d(volume);return 0;}z33d48fe8bf(volume,z2c7222ab3c);return 0
;}static int z0889a380fa(struct z4964f1d5f4*volume,struct z87953c6ebf*map){int 
ret=0;int ops=z0512bfc224|MAP_WRITE;if(ze79cbbfa4a(map)&&z03c66388ea(volume->
zc8e6cc3a13)==zdac4bfcb2a)return-EBUSY;if(test_bit(zacc33700d8,&volume->flags)&&
!test_bit(zb4978ba7ae,&volume->flags)&&!z45520bb515(volume))ops=MAP_READ|
MAP_WRITE;ret=z2bf1648a51(volume,map,ops);if(zdc056c7b40(map)){if(!ret&&volume->
metadata.extents.head&&!test_bit(zb4978ba7ae,&volume->flags))clear_bit(
zacc33700d8,&volume->flags);if(volume->metadata.extents.head){set_bit(
z2f9b7fc0d8,&volume->flags);if(test_bit(zacc33700d8,&volume->flags)&&!
z45520bb515(volume))ret=z4fd8c166a6(volume);}}return ret;}static int z973f0e8073
(struct z4964f1d5f4*volume,struct z87953c6ebf*map){if(volume->disk){return-
zad1d493a6b;}return z15d6091fb8(volume->data,map);}static int zcd0163ecee(struct
 z4964f1d5f4*volume){if(!volume){return-EINVAL;}if(volume->disk){return-
zad1d493a6b;}return z99fa386529(volume->data);}static int z90c7677cf1(struct 
z4964f1d5f4*volume,struct z87953c6ebf*map){struct zc2f837c735 zaf1d4f46ab;struct
 z718cdad054*new;int result=0;int z66bc8d3488;if(volume->metadata.extents.head)
return-EEXIST;if(!ze79cbbfa4a(map)||!zdc056c7b40(map)){z0e96e5b5b4(volume,
"ERROR: Metadata file is too big");return-EINVAL;}for(z66bc8d3488=0;z66bc8d3488<
map->z473eb14421;z66bc8d3488++){new=z76133370d0(map->extents[z66bc8d3488].
start_sect,map->extents[z66bc8d3488].z049dd48065,volume->metadata.extents.head);
if(IS_ERR(new)){z1acc38b162(volume->metadata.extents.head);volume->metadata.
extents.head=NULL;return PTR_ERR(new);}volume->metadata.extents.head=new;}
zecd82a79ce(volume->metadata.extents.head,volume->bdev,"metadata");if(!test_bit(
zacc33700d8,&volume->flags)){clear_bit(zb4978ba7ae,&volume->flags);return 0;}if(
test_bit(zb4978ba7ae,&volume->flags)){z0e96e5b5b4(volume,
"Volume was changed, set it as dirty");goto changed;}if(map->flags&z5140460292){
if(update_metadata(volume,zb529f94ecc)){z0e96e5b5b4(volume,
"ERROR: Failed to update metadata");return-EIO;}clear_bit(zacc33700d8,&volume->
flags);set_bit(z2f9b7fc0d8,&volume->flags);return 0;}result=z2a6948a421(volume->
bdev,&volume->metadata,&zaf1d4f46ab,z11482db68b);if(result){z0e96e5b5b4(volume,
"ERROR: Unable to read metadata file [%d]",result);set_bit(zb4978ba7ae,&volume->
flags);goto changed;}D("%s: Got hash from metadata: %x %x %x %x",volume_name(
volume),zaf1d4f46ab.hash[0],zaf1d4f46ab.hash[1],zaf1d4f46ab.hash[2],zaf1d4f46ab.
hash[3]);if(z3f1ae644f6(zaf1d4f46ab.hash,volume->metadata.data.hash)){
z0e96e5b5b4(volume,"Volume was not changed");if(z65f8f023c9(volume->zc8e6cc3a13)
){clear_bit(zacc33700d8,&volume->flags);set_bit(z2f9b7fc0d8,&volume->flags);}
return 0;}z0e96e5b5b4(volume,"Volume was changed, set it as dirty");set_bit(
zb4978ba7ae,&volume->flags);changed:set_bit(zacc33700d8,&volume->flags);set_bit(
z2f9b7fc0d8,&volume->flags);if(z65f8f023c9(volume->zc8e6cc3a13)){if(!z45520bb515
(volume)){z530f7bfcf5(volume->zc8e6cc3a13);result=z4fd8c166a6(volume);}}return 
result;}static int z87953c6ebf(struct z87953c6ebf*map){int ret;struct 
z4964f1d5f4*volume;volume=z17ef5db9c9(map->name);ret=z06f5205de4(volume);if(ret)
return ret;switch(map->type){case z869c67fd30:ret=z0889a380fa(volume,map);break;
case ze25ca68592:ret=z973f0e8073(volume,map);break;case z12c557a09c:ret=
z90c7677cf1(volume,map);break;default:ret=-EINVAL;break;}return ret;}static int 
z10d9edd461(struct z10d9edd461*zcf074bf1d4){int ret;struct z4964f1d5f4*volume;
volume=z17ef5db9c9(zcf074bf1d4->name);ret=z06f5205de4(volume);if(ret)return ret;
switch(zcf074bf1d4->cmd){case ze98f0bb3e2:if(zd4ec020f4e(volume))return-EBUSY;if
(volume->z51b17b1918.head){z0e96e5b5b4(volume,
"ERROR: some extents are already grabbed");return-EINVAL;}set_bit(z857b62ec9f,&
volume->flags);z0e96e5b5b4(volume,"File map grabbing has started");return 0;case
 z3d58b33c76:if(!zd4ec020f4e(volume)){z0e96e5b5b4(volume,
"ERROR: attempt to finish grabbing not being started");return-EINVAL;}clear_bit(
z857b62ec9f,&volume->flags);if(!volume->z51b17b1918.head){z0e96e5b5b4(volume,
"ERROR: there are no grabbed extents on grabbing end");return-EIO;}zcf074bf1d4->
z473eb14421=z71d84647be(volume->z51b17b1918.head);z0e96e5b5b4(volume,
"File extents map grabbing ended");return 0;case zc6712c8ed9:{int i=0;struct 
z718cdad054*extent;if(zd4ec020f4e(volume)){z0e96e5b5b4(volume,
"ERROR: %s: grabbed extents can't be fetched because grabbing wasn't finished",
__func__);return-EINVAL;}if(!volume->z51b17b1918.head){z0e96e5b5b4(volume,
"ERROR: %s: there are no extents to fetch",__func__);return-ESPIPE;}if(
zcf074bf1d4->z473eb14421!=z71d84647be(volume->z51b17b1918.head)){z0e96e5b5b4(
volume,
"ERROR: %s: number of requested extents isn't match number of grabbed ones",
__func__);return-EINVAL;}for(extent=volume->z51b17b1918.head;extent;extent=
extent->next,i++){zcf074bf1d4->extents[i].start_sect=extent->start;zcf074bf1d4->
extents[i].z049dd48065=extent->z049dd48065;}mutex_lock(&volume->z51b17b1918.lock
);z1acc38b162(volume->z51b17b1918.head);volume->z51b17b1918.head=0;mutex_unlock(
&volume->z51b17b1918.lock);return 0;}case z74d84864fd:if(!zd4ec020f4e(volume)){
z0e96e5b5b4(volume,"ERROR: grabbing can't be cancelled because hasn't started");
return-EINVAL;}z0e96e5b5b4(volume,"File extents map grabbing cancelled");
clear_bit(z857b62ec9f,&volume->flags);mutex_lock(&volume->z51b17b1918.lock);
z1acc38b162(volume->z51b17b1918.head);volume->z51b17b1918.head=0;mutex_unlock(&
volume->z51b17b1918.lock);return 0;default:z0e96e5b5b4(volume,
"ERROR: Unknown command in %s()",__func__);BUG();}}static int za3d171bd9e(struct
 z87953c6ebf*map){int i=0;int ret=0;int z3f070a1a19;struct z4964f1d5f4*volume;
struct z718cdad054*z27804fe7d9,*extent;volume=z17ef5db9c9(map->name);ret=
z06f5205de4(volume);if(ret)return ret;switch(map->type){case z869c67fd30:if(!
z65f8f023c9(volume->zc8e6cc3a13))return-z7650f15e91;z27804fe7d9=volume->
zc8e6cc3a13->extents.head;z3f070a1a19=z71d84647be(volume->zc8e6cc3a13->extents.
head);break;case ze25ca68592:if(!ze2638cd99c(volume->data))return-z2a92ef1fb2;
z27804fe7d9=volume->data->extents.head;z3f070a1a19=z71d84647be(volume->data->
extents.head);break;case z12c557a09c:if(!volume->metadata.extents.head)return-
z70a1a95680;z27804fe7d9=volume->metadata.extents.head;z3f070a1a19=z71d84647be(
volume->metadata.extents.head);break;default:return-EINVAL;}if(map->z473eb14421
==0){map->z473eb14421=z3f070a1a19;return ret;}if(map->z473eb14421!=z3f070a1a19)
return-EAGAIN;for(extent=z27804fe7d9;extent;extent=extent->next,i++){map->
extents[i].start_sect=extent->start;map->extents[i].z049dd48065=extent->
z049dd48065;}return ret;}static int z6f3f0b26a4(struct z6f3f0b26a4*unmap){int 
ret;struct z4964f1d5f4*volume;volume=z17ef5db9c9(unmap->name);ret=z06f5205de4(
volume);if(ret)return ret;switch(unmap->type){case za63bacb9ed:ret=zcd0163ecee(
volume);break;default:ret=-EINVAL;break;}return ret;}static int zd786363bc2(
struct zd786363bc2*dump){struct z4964f1d5f4*volume;volume=z17ef5db9c9(dump->name
);if(!volume)return-ENODEV;z5a088daf24(volume);return 0;}static void z01da32f6b0
(struct z4964f1d5f4*source,struct z4964f1d5f4*target){BUG_ON(!source);BUG_ON(!
target);source->link.to=target;source->link.direction=z718c42a902;target->link.
to=source;target->link.direction=z022f62b5ff;}static void z18255b71ad(struct 
z4964f1d5f4*source,struct z4964f1d5f4*target){BUG_ON(!source);BUG_ON(!target);
source->link.to=NULL;source->link.direction=z1b1eaae767;target->link.to=NULL;
target->link.direction=z1b1eaae767;}static int zae846161bb(struct z4964f1d5f4*
source,struct z4964f1d5f4*target){if(!source)return-ENOLINK;if(!target)return-
ENODEV;if(z0ed6bc6b0b(source)!=z0ed6bc6b0b(target))return-EFAULT;z01da32f6b0(
source,target);return 0;}static int zb33ddb43f0(struct zb33ddb43f0*restore){int 
err;struct z4964f1d5f4*source,*target;if(!restore)return-EINVAL;D(
"received restore command from %s to %s",restore->z19940d7717,restore->
zf1d6214a51);source=z17ef5db9c9(restore->z19940d7717);if(!source)return-ENOLINK;
err=z06f5205de4(source);if(err)return err;target=z17ef5db9c9(restore->
zf1d6214a51);err=z06f5205de4(target);if(err)return err;return zae846161bb(source
,target);}static int z48699f51cf(struct z48699f51cf*reset){struct z4964f1d5f4*
volume;volume=z17ef5db9c9(reset->name);if(!volume)return-ENODEV;if(volume->link.
to==NULL)return-ENOLINK;z18255b71ad(volume,volume->link.to);return 0;}static int
 z12be35daa4(unsigned int cmd,struct z90e465bd08 __user*user){int err;size_t len
=sizeof(struct z90e465bd08);struct z90e465bd08*bsi,*tmp;bsi=kmalloc(len,
GFP_KERNEL);if(!bsi)return-ENOMEM;if(copy_from_user(bsi,user,len)){err=-EFAULT;
goto out;}if(bsi->version!=BLKSNAP_IOCTL_VERSION){err=-z6d92b2fa20;goto out;}if(
len<bsi->size){len=bsi->size;tmp=krealloc(bsi,len,GFP_KERNEL);if(!tmp){err=-
ENOMEM;goto out;}bsi=tmp;if(copy_from_user(bsi,user,len)){err=-EFAULT;goto out;}
}switch(cmd){case z6f8ce6f09f:err=z3628a67cbe(&bsi->attach);break;case 
z7991db01f1:err=z32cb0cc233(&bsi->detach);break;case z45aa1f2beb:err=z038c9aa62a
(&bsi->device);break;case z80988c54ad:err=z5b91bfbc4a(&bsi->list);break;case 
zfec60266d7:err=z6008314d8b(&bsi->start);break;case z64da0cb687:err=zc0749aa884(
&bsi->stop);break;case za61da82071:err=zce1ec578d2(&bsi->show);break;case 
zea2044e93b:err=zb7b929fc6a(&bsi->z2c7222ab3c);break;case z75838fe263:err=
z87953c6ebf(&bsi->map);break;case z2875a428a5:err=z10d9edd461(&bsi->grab);break;
case z55d43d9aa5:err=za3d171bd9e(&bsi->map);break;case z9de3617f27:err=
z6f3f0b26a4(&bsi->unmap);break;case z59bbc748c7:err=zd786363bc2(&bsi->dump);
break;case ze55edfcaa2:err=zb33ddb43f0(&bsi->restore);break;case z24dad05246:err
=z48699f51cf(&bsi->reset);break;default:err=-ENOTTY;break;}if(err)goto out;if(
copy_to_user(user,bsi,len))err=-EFAULT;out:kfree(bsi);return err;}static bool 
z690d05d770(void){unsigned int tries;for(tries=zdbcb3682e7;tries>0;tries--){if(
mutex_trylock(&z6d663f46bd))return true;msleep(z786c86bccb);}return false;}
static void z8980a7496c(void){mutex_unlock(&z6d663f46bd);}static void ioctl_lock
(void){mutex_lock(&z6d663f46bd);}static long z90e465bd08(struct file*file,
unsigned int cmd,unsigned long arg){int ret;
#ifndef z245cba4d06
if(!capable(CAP_SYS_ADMIN))return-EPERM;
#endif 
if(_IOC_TYPE(cmd)!=z7f67affac7||_IOC_NR(cmd)>z8d77fd6a07)return-ENOTTY;if(!
z690d05d770())return-EBUSY;ret=z12be35daa4(cmd,(struct z90e465bd08 __user*)arg);
z8980a7496c();return(long)ret;}static const struct file_operations zda1aaa6dc6={
.unlocked_ioctl=z90e465bd08,.compat_ioctl=z90e465bd08,.owner=THIS_MODULE,.llseek
=noop_llseek,};static struct miscdevice z231846c21a={.minor=MISC_DYNAMIC_MINOR,.
name=za3d9410748,.fops=&zda1aaa6dc6,};static void zbd2df7828c(void){struct 
list_head*p,*q;list_for_each_safe(p,q,&z5c61784474){struct z4964f1d5f4*volume=
list_entry(p,struct z4964f1d5f4,z1f72606673);z957bf26383(volume);}}static int 
z0af2ae393d(struct notifier_block*,unsigned long,void*);static struct 
notifier_block z7c6b773809={.notifier_call=z0af2ae393d,.next=NULL};static void 
zc8506ccdc7(void){if(atomic_inc_return(&destroyed)>1)return;zbd2df7828c();
misc_deregister(&z231846c21a);unregister_blkdev(z71bf4e287b,za3d9410748);
za8a159e650();ze22d030cb5();}static void teardown(void){ioctl_lock();zc8506ccdc7
();z8980a7496c();unregister_reboot_notifier(&z7c6b773809);}static int 
z0af2ae393d(struct notifier_block*this,unsigned long event,void*buf){zc8506ccdc7
();return NOTIFY_DONE;}static int z034482b5c6(void){char*runtime_version=utsname
()->release;if(strcmp(z5d97114935,runtime_version)){z8be79bb9f5(
"ERROR: Kernel version mismatch (%s != %s)",z5d97114935,runtime_version);return-
EFAULT;}return 0;}static bool z662ad6327e(const char*name){struct file*fp;fp=
filp_open(name,O_RDONLY,0);if(fp==ERR_PTR(-ENOENT))return false;if(!IS_ERR(fp))
filp_close(fp,NULL);return true;}static int __init z1e1c74998a(void){int ret=0;
if(disabled){z8be79bb9f5("disabled from command line");return 0;}z8be79bb9f5(
"sizeof(struct rw_semaphore) = %lu",sizeof(struct rw_semaphore));z8be79bb9f5(
"sizeof(struct bitmap_chunk) = %lu",sizeof(struct z197aedd457));ret=z034482b5c6(
);if(ret)return ret;atomic_set(&zfa0617b68b,0);atomic_set(&destroyed,0);
ioctl_lock();if(z662ad6327e("/dev/"za3d9410748)){ret=-EEXIST;goto out;}ret=
misc_register(&z231846c21a);if(ret){goto out;}ret=z71bf4e287b=register_blkdev(0,
za3d9410748);if(z71bf4e287b<0)goto err;register_reboot_notifier(&z7c6b773809);
ret=z3e71cc6cc0();if(ret)goto err;ret=z1a91c81d9a();if(ret)goto err;z8be79bb9f5(
"loaded, version %s (API version %u)",BLKSNAP_VERSION,BLKSNAP_IOCTL_VERSION);
z8be79bb9f5("block object size: %zu",sizeof(struct z9a6dff1010));z8be79bb9f5(
"registered block device at major %d",z71bf4e287b);goto out;err:teardown();out:
z8980a7496c();return ret;}static void __exit z4ea1c34777(void){if(disabled)
return;teardown();z8be79bb9f5("unloaded");}module_init(z1e1c74998a);module_exit(
z4ea1c34777);MODULE_AUTHOR(z6be5024153);MODULE_DESCRIPTION(
"Rapid Recovery block device snapshot driver");MODULE_VERSION(BLKSNAP_VERSION);
MODULE_LICENSE(LICENSE);
