/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/vmalloc.h>
#include <linux/blkdev.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-device-utils.h"
#include "blksnap-volume.h"
#include "blksnap-bio-submit.h"
#include "blksnap-bio.h"
#include "blksnap-extent.h"
#include "blksnap-metadata.h"
bool z3f1ae644f6(__u32 left[],__u32 right[]){return(left[0]==right[0])&&(left[1]
==right[1])&&(left[2]==right[2])&&(left[3]==right[3]);}int z5c980244f9(struct 
block_device*bdev,struct zd3b1bd8300*metadata){int ret=0;struct z718cdad054*
extent;unsigned char*z48abf8c667;unsigned char*zc71582197f;uint64_t data_length=
0;size_t z77041ca42c=0;sector_t start_sect;data_length=zf81f99c042(metadata->
zbdd3160c2c);zc71582197f=vmalloc(data_length);if(!zc71582197f){z5769993871(bdev,
"ERROR: %s: Failed to allocate read buffer for blocks to calc hash",__func__);
return-ENOMEM;}z48abf8c667=zc71582197f;for(extent=metadata->zbdd3160c2c;extent;
extent=extent->next){start_sect=z18e6cf5184(bdev,extent->start);z77041ca42c=
extent->z049dd48065;ret=z323d633002(bdev,start_sect,z77041ca42c<<SECTOR_SHIFT,
z48abf8c667,z11482db68b);if(ret){z5769993871(bdev,
"ERROR: Unable to read disk for metadata hash [%d]",ret);goto z0a6635aba0;}
z48abf8c667+=z77041ca42c<<SECTOR_SHIFT;}ret=z48f3a5f993(zc71582197f,data_length,
metadata->data.hash);if(ret){z5769993871(bdev,
"ERROR: Unable to calculate hash [%d]",ret);memset(metadata->data.hash,0,
z1a8b5d96ec);}D("Calculated hash sum: %x %x %x %x",metadata->data.hash[0],
metadata->data.hash[1],metadata->data.hash[2],metadata->data.hash[3]);
z0a6635aba0:vfree(zc71582197f);return ret;}int z2a6948a421(struct block_device*
bdev,struct zd3b1bd8300*metadata,struct zc2f837c735*data,int op){int ret=0;
struct z718cdad054*extent;unsigned char*z48abf8c667;size_t z06bf654eb3,
z88986bc21f,z76744c10bb;sector_t start_sector;uint32_t data_size=sizeof(struct 
zc2f837c735);uint64_t z5e7a8fad9b=0;z5e7a8fad9b=zf81f99c042(metadata->extents.
head);if(WARN_ON(data_size>z5e7a8fad9b))return-E2BIG;z48abf8c667=(unsigned char*
)data;z76744c10bb=data_size;for(extent=metadata->extents.head;extent;extent=
extent->next){start_sector=z18e6cf5184(bdev,extent->start);z06bf654eb3=extent->
z049dd48065<<SECTOR_SHIFT;z88986bc21f=MIN(z06bf654eb3,z76744c10bb);ret=
z323d633002(bdev,start_sector,z88986bc21f,z48abf8c667,op);if(ret){z5769993871(
bdev,"ERROR: Unable to process metadata extent [%d]",ret);goto out;}z76744c10bb
-=z88986bc21f;z48abf8c667+=z88986bc21f;if(!z76744c10bb)break;}out:return ret;}
int update_metadata(struct z4964f1d5f4*volume,int mode){struct zd3b1bd8300*
metadata;int ret=0;metadata=&volume->metadata;if(unlikely(!metadata->extents.
head)){z0e96e5b5b4(volume,"WARNING: %s: Metadata is not mapped",__func__);return
-ENOENT;}if(mode==zc67824176f){z0e96e5b5b4(volume,"Reset metadata");memset(&
metadata->data.hash,0x0,z1a8b5d96ec);}else if(mode==zb529f94ecc){z0e96e5b5b4(
volume,"Update metadata");ret=z5c980244f9(volume->bdev,metadata);if(ret){
z0e96e5b5b4(volume,"ERROR: Failed to get blocks hash, Reset metadata [%d]",ret);
memset(&metadata->data.hash,0x0,z1a8b5d96ec);}}else{z0e96e5b5b4(volume,
"Store metadata");}ret=z2a6948a421(volume->bdev,metadata,&metadata->data,
zb38d6da9c4);if(ret)z0e96e5b5b4(volume,"ERROR: Unable to store metadata");return
 ret;}
