/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/blkdev.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-bio-queue.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-snapshot.h"
#include "blksnap-device-utils.h"
#include "blksnap-volume.h"
#include "blksnap-data.h"
#include "blksnap-cow-tree.h"
#include "blksnap-write-queue.h"
#include "blksnap-bitmap.h"
#include "blksnap-block.h"
#include "blksnap-cl-store.h"
#include "blksnap-bio-submit.h"
#define z4971e2071e		"sbd"
#define z2d407ddc38		(1 * HZ) 
int z71bf4e287b;static RELEASE_TYPE z89e03a7aaf(z8ade56fb9e){struct z4964f1d5f4*
volume=z7a30256663;if(!WARN_ON(!volume))atomic_dec(&volume->z939954fbe1);return 
z0fde54c0a4;}static int z90296b7d02(z5bea0c8f4f){struct z4964f1d5f4*volume=
z6a5e38821b;z5f1491e451;if(WARN_ON(!volume))return-ENXIO;if(mode&FMODE_WRITE)
return-EPERM;atomic_inc(&volume->z939954fbe1);return 0;}struct 
block_device_operations zb7a9c9660d={.owner=THIS_MODULE,.open=z90296b7d02,.
release=z89e03a7aaf,};static void z49264323fb(struct z4964f1d5f4*volume,sector_t
 addr,struct z9a6dff1010*z607b17d5a3){struct block_device*bdev=volume->device->
bdev;struct bio*bio;struct page*page;struct z9ce59fbd66 bp;gfp_t gfp_mask=(
in_atomic())?GFP_ATOMIC:GFP_NOIO;int err;bool completed;bio=bio_alloc(gfp_mask,1
);if(!bio){z0e96e5b5b4(volume,"%s: ERROR: Unable to allocate bio(%llu)",__func__
,addr);goto zad377459cb;}z7dfb21d984(bio,bdev);z9a3aa23558(bio)=addr;zb24ee97c39
(bio,READ,READ_SYNC);page=alloc_page(gfp_mask);if(!page){z0e96e5b5b4(volume,
"%s: ERROR: Unable to allocate bio(%llu) page",__func__,addr);goto z49fe607f31;}
if(bio_add_page(bio,page,PAGE_SIZE,0)!=PAGE_SIZE){z0e96e5b5b4(volume,
"%s: ERROR: Unable to add page into bio(%llu)",__func__,addr);goto z6cc21e748b;}
mutex_lock(&volume->z0f9dc72af9);z2dbcf3f6a8(volume,addr,IN_FLIGHT);mutex_unlock
(&volume->z0f9dc72af9);zfc42dd652b(bio,&bp);if(bio->bi_next){z0e96e5b5b4(volume,
"%s: ALERT #1: bio(0x%p, %llu:%u) has bi_next=0x%p",__func__,bio,z9a3aa23558(bio
),z6b5693e0ab(bio),bio->bi_next);bio->bi_next=NULL;}err=z76e5d47b75(bio,
z11482db68b);z273118234a(bio,&bp);if(err){z0e96e5b5b4(volume,
"%s: ERROR Reading Original CoW BIO %llu (0x%p)",__func__,z9a3aa23558(bio),bio);
mutex_lock(&volume->z0f9dc72af9);zca01cbe326(volume,addr,IN_FLIGHT);mutex_unlock
(&volume->z0f9dc72af9);goto z6cc21e748b;}completed=z29b49eca83(volume->data,
z607b17d5a3,bio,&err);mutex_lock(&volume->z0f9dc72af9);zca01cbe326(volume,addr,
IN_FLIGHT);mutex_unlock(&volume->z0f9dc72af9);if(err){z0e96e5b5b4(volume,
"%s: ERROR Putting CoW BIO %llu (0x%p)",__func__,z9a3aa23558(bio),bio);goto 
z6cc21e748b;}if(completed)goto z66537eedbc;if(bio->bi_next){z0e96e5b5b4(volume,
"%s: ALERT #2: bio(0x%p, %llu:%u) has bi_next=0x%p",__func__,bio,z9a3aa23558(bio
),z6b5693e0ab(bio),bio->bi_next);bio->bi_next=NULL;}err=z76e5d47b75(bio,
ze6aa9c5214);if(err){z0e96e5b5b4(volume,
"%s: ERROR Writing CoW Store BIO %llu (0x%p)",__func__,z9a3aa23558(bio),bio);
goto z6cc21e748b;}z9bf979875f(z607b17d5a3);z66537eedbc:bio_put(bio);return;
z6cc21e748b:put_page(page);z49fe607f31:bio_put(bio);zad377459cb:zcd229e7a6a(
volume);}static inline void z446a9fb23a(struct z4964f1d5f4*volume,struct bio*bio
,sector_t addr){struct z9a6dff1010*z607b17d5a3;z607b17d5a3=zcdc44c2966(volume,
addr);if(unlikely(!z607b17d5a3)){z0e96e5b5b4(volume,
"WARNING: Failed to insert block %llu into cow tree",(unsigned long long)addr);
zcd229e7a6a(volume);return;}if(zfce2568dba(z607b17d5a3))return;if(z3efcafecaa(
volume->data,z607b17d5a3)){if(!z170c7bf1e8(volume))z0e96e5b5b4(volume,
"(%s): WARNING: Data store depleted",z4719007b5e(volume));D(
"WARNING: Skipping COW for %llu, no space for CoW object",addr);zcd229e7a6a(
volume);return;}z49264323fb(volume,addr,z607b17d5a3);return;}void zfe571fbdf5(
struct z4964f1d5f4*volume,struct bio*bio){sector_t start,curr;unsigned int i,
count;start=zc145183281(bio);count=z704d4d74cb(bio,start);for(i=0,curr=start;i<
count;i++,curr+=z7be15aefe1){D(" C  %llu (%u/%u) 0x%p (%s)",curr,i+1,count,bio,
volume_name(volume));if(z2dbcf3f6a8(volume,curr,z8d7ae0fe64)){set_bit(
zacc33700d8,&volume->flags);zcd229e7a6a(volume);}if(z170c7bf1e8(volume))continue
;z446a9fb23a(volume,bio,curr);}volume->device->zb9060ff5bc(z97c6426121(bio),bio)
;}int ze902a23efb(struct z4964f1d5f4*volume,sector_t addr){if(z2dbcf3f6a8(volume
,addr,z8d7ae0fe64)){set_bit(zacc33700d8|z2f9b7fc0d8,&volume->flags);return-
EINVAL;}if(!test_bit(zacc33700d8,&volume->flags)&&z65f8f023c9(volume->
zc8e6cc3a13)){if(unlikely(zf274290909(volume,addr,false)))z0e96e5b5b4(volume,
"ERROR: Unable to put block %llu",addr);}return 0;}void z3bfa674a26(struct 
z4964f1d5f4*volume,struct bio*bio){sector_t start,curr;unsigned int i,count;
start=zc145183281(bio);count=z704d4d74cb(bio,start);for(i=0,curr=start;i<count;i
++,curr+=z7be15aefe1){D(" R  %llu (%u/%u) 0x%p (%s)",curr,i+1,count,bio,
volume_name(volume));if(ze902a23efb(volume,curr)){z0e96e5b5b4(volume,
"ERROR: Can't set block %llu as changed",curr);return;}}}struct bio*z62c6b78086(
struct z3fc80aee23*bd,struct z4964f1d5f4*volume,struct bio*bio){sector_t start,
curr;unsigned int i,count;if(test_bit(zacc33700d8,&volume->flags)&&test_bit(
z2f9b7fc0d8,&volume->flags)&&!z45520bb515(volume)){return bio;}start=zc145183281
(bio);count=z704d4d74cb(bio,start);for(i=0,curr=start;i<count;i++,curr+=
z7be15aefe1){D(" C  %llu (%u/%u) 0x%p (%s)",curr,i+1,count,bio,volume_name(
volume));if(z2dbcf3f6a8(volume,curr,z8d7ae0fe64)){set_bit(zacc33700d8,&volume->
flags);zcd229e7a6a(volume);}if(z45520bb515(volume)&&z170c7bf1e8(volume))continue
;if(!z45520bb515(volume)||(zed315d8bae(volume)&&!z2b33a5c958(volume,curr,
zbf0de702a1)))ze902a23efb(volume,curr);else z446a9fb23a(volume,bio,curr);}return
 bio;}static inline int z32a41bb53a(struct bio*bio){sector_t z69441e94e0=
z9a3aa23558(bio);sector_t z7924a23ae8=z69441e94e0+(z6b5693e0ab(bio)>>
SECTOR_SHIFT);sector_t z808de357e8=(z7924a23ae8>>zf0d12088d2)<<zf0d12088d2;if(
z7924a23ae8==z808de357e8)z808de357e8-=z7be15aefe1;return z808de357e8-z69441e94e0
;}static inline bool zf982d64c04(struct bio*bio){return(z704d4d74cb(bio,
zc145183281(bio))>1);}static void z3090b72b14(struct request_queue*q,struct bio*
bio){WARN_ON(bio->bi_next);generic_make_request(bio);}static void zf94c8b5ffb(
struct request_queue*q,struct bio*bio);static void zf0653597d3(struct 
request_queue*q,struct bio*parent){int z394ec8a073=z32a41bb53a(parent);
#if BIO_SPLIT_4_ARGS
struct bio*bio;
#else
struct bio_pair*bp;struct z4964f1d5f4*volume=q->queuedata;if(bio_segments(parent
)>1){z0e96e5b5b4(volume,"WARNING: BIO request (%p, %u, %lu) is too big to split"
,parent,z6b5693e0ab(parent),z9a3aa23558(parent));z129afb1518(parent,-EIO);
zcd229e7a6a(volume);return;}
#endif
#if BIO_SPLIT_4_ARGS
bio=z47a1d5b9cc(parent,z394ec8a073);bio_chain(bio,parent);WARN_ON(zf982d64c04(
parent));zf94c8b5ffb(q,parent);while(zf982d64c04(bio)){struct bio*za8506a408d;
z394ec8a073=z32a41bb53a(bio);za8506a408d=z47a1d5b9cc(bio,z394ec8a073);bio_chain(
za8506a408d,bio);WARN_ON(zf982d64c04(bio));zf94c8b5ffb(q,bio);bio=za8506a408d;}
zf94c8b5ffb(q,bio);
#else
bp=z47a1d5b9cc(parent,z394ec8a073);zf94c8b5ffb(q,&bp->bio1);zf94c8b5ffb(q,&bp->
bio2);bio_pair_release(bp);
#endif
}static void zf94c8b5ffb(struct request_queue*q,struct bio*bio){struct 
z4964f1d5f4*volume=q->queuedata;sector_t start;struct z9a6dff1010*z607b17d5a3;
int err;bool z4d1fde9720;start=zc145183281(bio);mutex_lock(&volume->z0f9dc72af9)
;if(!z16bb2b3155(volume,start)){z3090b72b14(q,bio);mutex_unlock(&volume->
z0f9dc72af9);return;}if(!z2b33a5c958(volume,start,z442071e80a)){z3090b72b14(q,
bio);mutex_unlock(&volume->z0f9dc72af9);return;}mutex_unlock(&volume->
z0f9dc72af9);z607b17d5a3=z768d3dfb71(volume,start);BUG_ON(!z607b17d5a3);while(!
zfce2568dba(z607b17d5a3)){if(z170c7bf1e8(volume)){z129afb1518(bio,-EIO);return;}
while(z2b33a5c958(volume,start,IN_FLIGHT)){if(z170c7bf1e8(volume)){z129afb1518(
bio,-EIO);return;}io_schedule();}}z4d1fde9720=zff39f745be(volume->data,
z607b17d5a3,bio,&err);if(z4d1fde9720){z129afb1518(bio,err?-EIO:0);}else{
z3090b72b14(q,bio);}}static z76abdd5d38 z9da66e0d17(struct request_queue*q,
struct bio*bio){struct z4964f1d5f4*volume=q->queuedata;if(!z45520bb515(volume)){
z129afb1518(bio,-ENODEV);goto out;}if(z170c7bf1e8(volume)){z129afb1518(bio,-EIO)
;goto out;}if(bio_data_dir(bio)!=READ){z8be79bb9f5(
"attempted write at %llu on read-only snapshot device",z9a3aa23558(bio));
z129afb1518(bio,-EROFS);goto out;}z9a3aa23558(bio)+=volume->start_sector;
z7dfb21d984(bio,volume->device->bdev);if(zf982d64c04(bio))zf0653597d3(q,bio);
else zf94c8b5ffb(q,bio);out:return z49862b0790;}static int zc98a6ebd94(struct 
z4964f1d5f4*volume){int ret=0;struct gendisk*disk=alloc_disk(1);if(WARN_ON(!disk
))return-ENOMEM;disk->queue=blk_alloc_queue(GFP_KERNEL);if(WARN_ON(!disk->queue)
){ret=-ENODEV;goto err;}blk_queue_make_request(disk->queue,z9da66e0d17);
blk_set_stacking_limits(&disk->queue->limits);bdev_stack_limits(&disk->queue->
limits,volume->bdev,0);blk_queue_max_hw_sectors(disk->queue,z7be15aefe1);
blk_queue_max_segments(disk->queue,1);z796f4d2d79(disk->queue);disk->queue->
queuedata=volume;disk->fops=&zb7a9c9660d;disk->major=z71bf4e287b;disk->
first_minor=volume->id;disk->private_data=volume;if(snprintf(disk->disk_name,
DISK_NAME_LEN,"%s%d",z4971e2071e,volume->id)>=DISK_NAME_LEN){ret=-EFAULT;goto 
err;}volume->disk=disk;set_disk_ro(disk,1);set_capacity(disk,z0ed6bc6b0b(volume)
);out:return ret;err:put_disk(disk);goto out;}static void z0b01620d03(struct 
z4964f1d5f4*volume){if(volume->disk)add_disk(volume->disk);}int z35e8447306(
struct z4964f1d5f4*volume,struct z6008314d8b*start){int rc=0;if(WARN_ON(
zc98a6ebd94(volume)))return-EFAULT;if(start->flags&z3984604f7d){if(test_bit(
zacc33700d8,&volume->flags)){z0e96e5b5b4(volume,
"ERROR: Try to start an incremental snapshot on a dirty volume");rc=-z76972b287e
;goto zff428db45e;}else{set_bit(zb173b15554,&volume->flags);}}z2671aaaf2e(volume
);if(!test_bit(zacc33700d8,&volume->flags))z0c4f400dc1(volume);rc=z744271866d(
volume);if(rc){z0e96e5b5b4(volume,"ERROR: Can't start Write BIO kthread");return
 rc;}set_bit(zf1196f52b3,&volume->flags);z0b01620d03(volume);z0e96e5b5b4(volume,
"Snapshot available at %s",z4719007b5e(volume));out:return rc;zff428db45e:
put_disk(volume->disk);goto out;}static void zde2ef3966c(struct z4964f1d5f4*
volume){if(!volume->disk)return;del_gendisk(volume->disk);put_disk(volume->disk)
;blk_cleanup_queue(volume->disk->queue);volume->disk=NULL;}int z48894a7ef3(
struct z4964f1d5f4*volume,bool cancel){int ret=0,za8b823ceea;bool frozen;bool 
z613bffb1a8=false;bool zd5c1b6aeef;clear_bit(zf1196f52b3,&volume->flags);
zdd25bbacff(volume);zde2ef3966c(volume);ze9df4351d7(volume->data);zd5c1b6aeef=
test_bit(z55f91a65ec,&volume->fs_flags);if(!zd5c1b6aeef){if(IS_ERR(z2c0cb1aa81(
volume))){z0e96e5b5b4(volume,"ERROR: failed to freeze filesystem");ret=-ENXIO;
frozen=false;}else{frozen=true;}}if(ret||z170c7bf1e8(volume)){z2671aaaf2e(volume
);if(!cancel)cancel=z613bffb1a8=true;}if(z65f8f023c9(volume->zc8e6cc3a13)&&!
cancel)z530f7bfcf5(volume->zc8e6cc3a13);za8b823ceea=zc11a30e286(volume,cancel);
if(za8b823ceea){ret=za8b823ceea;set_bit(zacc33700d8,&volume->flags);set_bit(
z2f9b7fc0d8,&volume->flags);if(!cancel)cancel=z613bffb1a8=true;}if(!cancel&&!ret
){clear_bit(zb4978ba7ae,&volume->flags);clear_bit(zacc33700d8,&volume->flags);
set_bit(z2f9b7fc0d8,&volume->flags);}clear_bit(zb173b15554,&volume->flags);if(!
zd5c1b6aeef){if(frozen&&ze9c7b9d72d(volume)){z0e96e5b5b4(volume,
"ERROR: failed to thaw filesystem");ret=-ENXIO;}}if(z70ae0dca46(volume)){
z0e96e5b5b4(volume,"ERROR: CoW tree has had errors on %s snapshot",cancel?
"cancelling":"completing");ret=-ENXIO;}if(!z613bffb1a8){z0e96e5b5b4(volume,
"Snapshot ended (mode: %s)%s",cancel?"cancel":"stop",ret?", error(s) occurred":
"");}else{z0e96e5b5b4(volume,
"WARNING: Snapshot was cancelled due to errors. Volume is%s dirty.",test_bit(
zacc33700d8,&volume->flags)?"":" not");ret=0;}return ret;}
