#!/bin/bash
TEST_DIR=$(cd $(dirname $0); pwd)
OUTPUT_FILE=$TEST_DIR/../blksnap-config.h
MAKE_LOG=$TEST_DIR/make.log

rm -f $MAKE_LOG

if [[ $1 == "clean" ]]; then
	make -C $KERNELDIR M=$TEST_DIR clean
	rm -f $OUTPUT_FILE
	exit 0
fi

echo "CONFIGURE:"
echo "#ifndef BLKSNAP_CONFIG_H" > $OUTPUT_FILE
echo "#define BLKSNAP_CONFIG_H" >> $OUTPUT_FILE

for source_file in `ls $TEST_DIR/*.c`
do
	TEST_NAME=`basename $source_file | sed 's/\.c//g'`
	ARG_NAME=`echo $TEST_NAME | tr a-z A-Z`
	RESULT=`make -C $KERNELDIR M=$TEST_DIR $TEST_NAME.o >> \
		$MAKE_LOG 2>&1 && echo 1 || echo 0`
	echo "#define $ARG_NAME   $RESULT " >> $OUTPUT_FILE
	echo "  $ARG_NAME=$RESULT"
done
echo "#endif" >> $OUTPUT_FILE

